var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var FilterButtonList_exports = {};
__export(FilterButtonList_exports, {
  default: () => FilterButtonList_default
});
module.exports = __toCommonJS(FilterButtonList_exports);
var import_futil = __toESM(require("futil"));
var import_fp = __toESM(require("lodash/fp.js"));
var import_react = __toESM(require("react"));
var import_react_recompose = require("react-recompose");
var import_greyVest = require("./greyVest/index.js");
var import_purgatory = require("./purgatory/index.js");
var import_hoc = require("./utils/hoc.js");
var import_theme = require("./utils/theme.js");
var import_styles = __toESM(require("./styles/index.js"));
var import_search = require("./utils/search.js");
var import_FilterAdder = require("./FilterAdder.js");
var import_fields = require("./utils/fields.js");
let FilterButtonItem = import_fp.default.flow(
  (0, import_react_recompose.setDisplayName)("FilterButtonItem"),
  import_theme.withTheme
)(
  ({
    node,
    tree,
    fields,
    mapNodeToProps,
    mapNodeToLabel,
    theme: { Button, FilterButton = Button, UnmappedNodeComponent, Modal }
  }) => {
    let mappedProps = mapNodeToProps(node, fields);
    let modal = import_react.default.useState(false);
    let title = (
      // we really need a title, so here's every possible fallback
      mapNodeToLabel(node, fields) || import_fp.default.get("label", mappedProps) || import_fp.default.get([node.field, "label"], fields) || node.field || node.key
    );
    let description = import_fp.default.get("description", mappedProps);
    return /* @__PURE__ */ import_react.default.createElement("div", null, /* @__PURE__ */ import_react.default.createElement(
      import_purgatory.CheckButton,
      {
        primary: node.hasValue,
        checked: node.hasValue,
        onClick: () => {
          import_futil.default.on(modal)();
          tree.mutate(node.path, { paused: false });
        },
        theme: { Button: FilterButton }
      },
      title
    ), /* @__PURE__ */ import_react.default.createElement(Modal, { open: modal }, /* @__PURE__ */ import_react.default.createElement(import_greyVest.Flex, { column: true, className: "filter-button-modal" }, /* @__PURE__ */ import_react.default.createElement("h1", null, title), description && /* @__PURE__ */ import_react.default.createElement("div", { className: "filter-description" }, description), /* @__PURE__ */ import_react.default.createElement("div", { className: "filter-component" }, /* @__PURE__ */ import_react.default.createElement(
      import_greyVest.Dynamic,
      {
        ...{
          component: UnmappedNodeComponent,
          tree,
          node,
          path: import_fp.default.toArray(node.path),
          ...mappedProps
        }
      }
    )), /* @__PURE__ */ import_react.default.createElement(import_greyVest.Flex, { style: { justifyContent: "flex-end" } }, /* @__PURE__ */ import_react.default.createElement(Button, { onClick: () => tree.clear(node.path) }, "Clear Filter"), /* @__PURE__ */ import_react.default.createElement(
      Button,
      {
        primary: true,
        onClick: () => {
          import_futil.default.off(modal)();
          tree.mutate(node.path, { paused: true });
        },
        style: { marginLeft: "10px" }
      },
      "Done"
    )))));
  }
);
let GroupBox = ({ nodeJoinColor, children, nested, className, style }) => /* @__PURE__ */ import_react.default.createElement(
  import_greyVest.Flex,
  {
    wrap: true,
    className: `${className} ${nested ? "nested" : ""}`,
    alignItems: "center",
    style: { borderColor: nodeJoinColor, ...style }
  },
  children
);
let FilterButtonList = (0, import_hoc.contexturifyWithoutLoader)(
  ({
    node,
    tree,
    fields = {},
    mapNodeToProps = import_fp.default.noop,
    mapNodeToLabel = import_fp.default.noop,
    allowDuplicateFields = false,
    className = "",
    addFilters = false,
    nested = false,
    style,
    children,
    theme: { Icon, Button, FilterButton = Button }
  }) => {
    let options = allowDuplicateFields ? (0, import_fields.fieldsToOptions)(fields) : (0, import_FilterAdder.unusedOptions)(fields);
    return /* @__PURE__ */ import_react.default.createElement(
      GroupBox,
      {
        className: `filter-button-list ${className}`,
        ...{ nested, style },
        nodeJoinColor: node && import_styles.default.joinColor(node)
      },
      children,
      import_fp.default.map((child) => {
        let Component = child.children ? FilterButtonList : FilterButtonItem;
        return /* @__PURE__ */ import_react.default.createElement(
          Component,
          {
            key: child.path,
            nested: true,
            ...{
              tree,
              node: child,
              fields,
              mapNodeToProps,
              mapNodeToLabel,
              className
            }
          }
        );
      }, import_fp.default.get("children", node)),
      addFilters && !nested && /* @__PURE__ */ import_react.default.createElement("div", null, /* @__PURE__ */ import_react.default.createElement(
        import_purgatory.ModalPicker,
        {
          options,
          className: "check-button",
          onChange: (addedFields) => import_fp.default.each(
            ({ field }) => tree.add(node.path, (0, import_search.newNodeFromField)({ field, fields })),
            addedFields
          ),
          label: /* @__PURE__ */ import_react.default.createElement(import_greyVest.Flex, { alignItems: "center", justifyContent: "center" }, /* @__PURE__ */ import_react.default.createElement(Icon, { icon: "AddColumn" }), addFilters !== true && /* @__PURE__ */ import_react.default.createElement(import_react.default.Fragment, null, "\xA0", addFilters)),
          theme: { Button: FilterButton }
        }
      ))
    );
  }
);
var FilterButtonList_default = FilterButtonList;
