var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var FilterList_exports = {};
__export(FilterList_exports, {
  FilterActions: () => FilterActions,
  Label: () => Label,
  default: () => FilterList_default
});
module.exports = __toCommonJS(FilterList_exports);
var import_react = __toESM(require("react"));
var import_fp = __toESM(require("lodash/fp.js"));
var import_futil = __toESM(require("futil"));
var import_react_recompose = require("react-recompose");
var import_mobx_react = require("mobx-react");
var import_greyVest = require("./greyVest/index.js");
var import_fields = require("./utils/fields.js");
var import_hoc = require("./utils/hoc.js");
var import_generic = require("./styles/generic.js");
var import_search = require("./utils/search.js");
var import_theme = require("./utils/theme.js");
let FilterActions = import_fp.default.flow(
  (0, import_react_recompose.setDisplayName)("FilterActions"),
  import_mobx_react.observer,
  import_theme.withTheme
)(
  ({
    node,
    tree,
    fields,
    popover,
    theme: { DropdownItem, Popover, Modal, NestedPicker }
  }) => {
    let modal = import_react.default.useState(false);
    let typeOptions = import_fp.default.flow(
      import_fp.default.getOr([], [node.field, "typeOptions"]),
      import_fp.default.without([node.type])
    )(fields);
    return /* @__PURE__ */ import_react.default.createElement(import_react.default.Fragment, null, /* @__PURE__ */ import_react.default.createElement(Modal, { open: modal }, /* @__PURE__ */ import_react.default.createElement(
      NestedPicker,
      {
        options: (0, import_fields.fieldsToOptions)(fields),
        onChange: (pickedFields) => {
          if (pickedFields.length > 0)
            tree.replace(
              node.path,
              (0, import_search.transformNodeFromField)({
                field: import_fp.default.last(pickedFields).field,
                fields
              })
            );
          import_futil.default.off(modal)();
        }
      }
    )), /* @__PURE__ */ import_react.default.createElement(
      Popover,
      {
        open: popover,
        arrow: false,
        position: "bottom center",
        style: { width: "auto" }
      },
      !import_fp.default.isEmpty(typeOptions) && /* @__PURE__ */ import_react.default.createElement(import_react.default.Fragment, null, /* @__PURE__ */ import_react.default.createElement(DropdownItem, { className: "filter-actions-selected-type" }, "Filter type: ", /* @__PURE__ */ import_react.default.createElement("strong", null, (0, import_search.getTypeLabel)(tree, node.type))), import_fp.default.map(
        (x) => /* @__PURE__ */ import_react.default.createElement(
          DropdownItem,
          {
            key: x.value,
            onClick: () => tree.replace(
              node.path,
              (0, import_search.newNodeFromType)(x.value, fields, node)
            )
          },
          "\u2014Change to ",
          x.label
        ),
        (0, import_search.getTypeLabelOptions)(tree, typeOptions)
      ), /* @__PURE__ */ import_react.default.createElement("div", { className: "filter-actions-separator" })),
      /* @__PURE__ */ import_react.default.createElement(DropdownItem, { onClick: import_futil.default.on(modal) }, "Pick Field"),
      (node.hasValue || false) && /* @__PURE__ */ import_react.default.createElement(DropdownItem, { onClick: () => tree.clear(node.path) }, "Clear Filter"),
      /* @__PURE__ */ import_react.default.createElement(DropdownItem, { onClick: () => tree.remove(node.path) }, "Delete Filter")
    ));
  }
);
let Label = import_fp.default.flow(
  (0, import_react_recompose.setDisplayName)("Label"),
  import_mobx_react.observer,
  import_theme.withTheme
)(({ tree, node, fields, children, theme: { Icon }, ...props }) => {
  let popover = import_react.default.useState(false);
  let modal = import_react.default.useState(false);
  let field = import_fp.default.get("field", node);
  return /* @__PURE__ */ import_react.default.createElement(
    import_greyVest.Flex,
    {
      className: `filter-field-label ${import_fp.default.get("hasValue", node) ? "filter-field-has-value" : ""}`.trim(),
      style: {
        cursor: "pointer",
        alignItems: "center",
        justifyContent: "space-between"
      }
    },
    /* @__PURE__ */ import_react.default.createElement("span", { ...props }, children || import_fp.default.get([field, "label"], fields) || field || ""),
    tree && node && /* @__PURE__ */ import_react.default.createElement(
      import_react.default.Fragment,
      null,
      /* @__PURE__ */ import_react.default.createElement(
        "span",
        {
          onClick: node.paused ? null : (e) => {
            e.stopPropagation();
            import_futil.default.flip(popover)();
          }
        },
        /* @__PURE__ */ import_react.default.createElement("span", { className: "filter-field-label-icon" }, /* @__PURE__ */ import_react.default.createElement(Icon, { icon: "TableColumnMenu" })),
        /* @__PURE__ */ import_react.default.createElement(
          FilterActions,
          {
            node,
            tree,
            fields,
            popover,
            modal
          }
        )
      ),
      // Whitespace separator
      /* @__PURE__ */ import_react.default.createElement("div", { style: { flexGrow: 1 } })
    )
  );
});
let FilterList = import_fp.default.flow(
  (0, import_react_recompose.setDisplayName)("FilterList"),
  import_hoc.contexturifyWithoutLoader
)(
  ({
    tree,
    node,
    fields,
    mapNodeToProps = import_fp.default.noop,
    mapNodeToLabel = import_fp.default.noop,
    className,
    style,
    theme: { UnmappedNodeComponent, Button }
  }) => {
    let updateRequired = tree.disableAutoUpdate && tree?.tree?.markedForUpdate;
    return /* @__PURE__ */ import_react.default.createElement("div", { style, className }, import_fp.default.map(
      (child) => child.children ? /* @__PURE__ */ import_react.default.createElement(
        FilterList,
        {
          key: child.path,
          tree,
          node: child,
          fields,
          mapNodeToProps,
          mapNodeToLabel,
          className: "filter-list-group",
          style: (0, import_generic.bdJoin)(child)
        }
      ) : /* @__PURE__ */ import_react.default.createElement(
        import_greyVest.Expandable,
        {
          key: child.path,
          className: "filter-list-item",
          isOpen: !child.paused,
          Label: /* @__PURE__ */ import_react.default.createElement(Label, { tree, node: child, fields }, mapNodeToLabel(child, fields)),
          onClick: () => tree && tree.mutate(child.path, { paused: !child.paused })
        },
        /* @__PURE__ */ import_react.default.createElement("div", { className: "filter-list-item-contents" }, /* @__PURE__ */ import_react.default.createElement(
          import_greyVest.Dynamic,
          {
            ...{
              component: UnmappedNodeComponent,
              tree,
              node: child,
              path: import_fp.default.toArray(child.path),
              ...mapNodeToProps(child, fields)
            }
          }
        ))
      ),
      import_fp.default.get("children", node)
    ), /* @__PURE__ */ import_react.default.createElement(
      "div",
      {
        className: `apply-filter ${updateRequired ? "active" : ""}`,
        onClick: (e) => {
          e.stopPropagation();
          tree.triggerUpdate();
        }
      },
      /* @__PURE__ */ import_react.default.createElement(Button, { primary: true }, /* @__PURE__ */ import_react.default.createElement(import_greyVest.Flex, { justifyContent: "center", alignItems: "center" }, "Search"))
    ));
  }
);
var FilterList_default = FilterList;
