var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var MemoryTable_exports = {};
__export(MemoryTable_exports, {
  default: () => MemoryTable_default,
  useMemoryTree: () => useMemoryTree
});
module.exports = __toCommonJS(MemoryTable_exports);
var import_fp = __toESM(require("lodash/fp.js"));
var import_contexture = __toESM(require("contexture"));
var import_provider_memory = __toESM(require("contexture/provider-memory/index.js"));
var import_exampleTypes = __toESM(require("contexture/provider-memory/exampleTypes.js"));
var import_react = __toESM(require("react"));
var import_contexture_mobx = __toESM(require("./utils/contexture-mobx.js"));
var import_schema = require("./utils/schema.js");
var import_exampleTypes2 = require("./exampleTypes/index.js");
let useMemoryTree = ({
  records,
  debug,
  resultsNode,
  criteriaNodes = []
} = {}) => {
  let makeTree = () => (0, import_contexture_mobx.default)({
    debounce: 0,
    service: (0, import_contexture.default)({
      debug,
      schemas: { data: { memory: memoryStorage } },
      providers: { memory: { ...import_provider_memory.default, types: (0, import_exampleTypes.default)() } }
    })
  })({
    key: "root",
    schema: "data",
    children: [
      {
        key: "results",
        type: "results",
        pageSize: 50,
        ...resultsNode
      },
      {
        key: "criteria",
        type: "group",
        children: import_fp.default.castArray(criteriaNodes)
      }
    ]
  });
  let [memoryStorage] = (0, import_react.useState)({ records: [] });
  let [dependency, setDependency] = (0, import_react.useState)([resultsNode, criteriaNodes]);
  let [tree, setTree] = (0, import_react.useState)(makeTree);
  if (!import_fp.default.isEqual(dependency, [resultsNode, criteriaNodes])) {
    setDependency([resultsNode, criteriaNodes]);
    tree = makeTree();
    setTree(tree);
  }
  let setRecords = (records2) => {
    if (records2 !== memoryStorage.records) {
      memoryStorage.records = records2;
      tree.refresh(["root"]);
    }
  };
  if (records.then)
    Promise.resolve(records).then(setRecords);
  else
    setRecords(records);
  return tree;
};
let MemoryTable = ({ data, debug, resultsNode, criteriaNodes, ...props }) => {
  let tree = useMemoryTree({
    records: data,
    debug,
    resultsNode,
    criteriaNodes
  });
  return /* @__PURE__ */ import_react.default.createElement(
    import_exampleTypes2.ResultTable,
    {
      tree,
      path: ["root", "results"],
      criteria: ["root", "criteria"],
      mapNodeToProps: (0, import_schema.componentForType)(import_exampleTypes2.TypeMap),
      ...props
    }
  );
};
var MemoryTable_default = MemoryTable;
