var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var SearchFilters_exports = {};
__export(SearchFilters_exports, {
  AddableFilterList: () => AddableFilterList,
  FiltersBox: () => FiltersBox,
  SearchTree: () => SearchTree,
  default: () => SearchFilters_default
});
module.exports = __toCommonJS(SearchFilters_exports);
var import_react = __toESM(require("react"));
var import_fp = __toESM(require("lodash/fp.js"));
var import_prop_types = __toESM(require("prop-types"));
var import_futil = __toESM(require("futil"));
var import_mobx_react = require("mobx-react");
var import_FilterList = __toESM(require("./FilterList.js"));
var import_FilterAdder = __toESM(require("./FilterAdder.js"));
var import_queryBuilder = __toESM(require("./queryBuilder/index.js"));
var import_purgatory = require("./purgatory/index.js");
var import_greyVest = require("./greyVest/index.js");
var import_theme = require("./utils/theme.js");
let SearchTree = () => {
};
let LabelledList = ({ list, Component }) => import_futil.default.mapIndexed(
  ({ label, ...props }, i) => /* @__PURE__ */ import_react.default.createElement(import_react.default.Fragment, { key: i }, label && /* @__PURE__ */ import_react.default.createElement("h3", null, label), /* @__PURE__ */ import_react.default.createElement(Component, { ...props })),
  list
);
let AddableFilterList = (props) => /* @__PURE__ */ import_react.default.createElement(import_react.default.Fragment, null, /* @__PURE__ */ import_react.default.createElement(import_FilterList.default, { ...props }), /* @__PURE__ */ import_react.default.createElement(import_FilterAdder.default, { ...props, uniqueFields: !props.allowDuplicateFields }));
let FiltersBox = (0, import_theme.withTheme)(({ theme: { Box }, ...props }) => /* @__PURE__ */ import_react.default.createElement(Box, { className: "filter-list" }, /* @__PURE__ */ import_react.default.createElement(AddableFilterList, { ...props })));
FiltersBox.displayName = "FiltersBox";
let BasicSearchFilters = (0, import_theme.withTheme)(
  ({
    setMode,
    disableAdvancedMode,
    trees,
    children,
    BasicFilters,
    theme: { Icon }
  }) => /* @__PURE__ */ import_react.default.createElement("div", null, /* @__PURE__ */ import_react.default.createElement(import_greyVest.Flex, { alignItems: "center", justifyContent: "space-between" }, /* @__PURE__ */ import_react.default.createElement("h1", null, "Filters"), /* @__PURE__ */ import_react.default.createElement("div", null, /* @__PURE__ */ import_react.default.createElement(
    import_greyVest.Popover,
    {
      position: "bottom right",
      trigger: /* @__PURE__ */ import_react.default.createElement(import_greyVest.DropdownItem, null, /* @__PURE__ */ import_react.default.createElement(Icon, { icon: "TableColumnMenu" }))
    },
    setMode && /* @__PURE__ */ import_react.default.createElement(import_greyVest.DropdownItem, { onClick: () => setMode("resultsOnly") }, "Hide Filters"),
    /* @__PURE__ */ import_react.default.createElement(import_purgatory.TreePauseButton, { Component: import_greyVest.DropdownItem }, children),
    setMode && !disableAdvancedMode && /* @__PURE__ */ import_react.default.createElement(import_greyVest.DropdownItem, { onClick: () => setMode("builder") }, "Advanced Search Builder")
  ))), /* @__PURE__ */ import_react.default.createElement(LabelledList, { list: trees, Component: BasicFilters }))
);
let BuilderSearchFilters = ({ setMode, trees, BuilderFilters }) => /* @__PURE__ */ import_react.default.createElement("div", null, /* @__PURE__ */ import_react.default.createElement(import_greyVest.Flex, { alignItems: "center", justifyContent: "space-between" }, /* @__PURE__ */ import_react.default.createElement("h1", null, "Filters"), setMode && /* @__PURE__ */ import_react.default.createElement(import_greyVest.LinkButton, { onClick: () => setMode("basic") }, "Back to Regular Search")), /* @__PURE__ */ import_react.default.createElement(LabelledList, { list: trees, Component: BuilderFilters }));
let SearchFilters = ({
  mode,
  setMode,
  disableAdvancedMode,
  children,
  // pass allowDuplicateFields in children to override uniqueFields
  BasicFilters = FiltersBox,
  BuilderFilters = import_queryBuilder.default
}) => {
  let trees = import_fp.default.flow(import_react.default.Children.toArray, import_fp.default.map("props"))(children);
  return mode === "basic" ? /* @__PURE__ */ import_react.default.createElement(
    BasicSearchFilters,
    {
      ...{ trees, setMode, disableAdvancedMode, children, BasicFilters }
    }
  ) : mode === "builder" ? /* @__PURE__ */ import_react.default.createElement(BuilderSearchFilters, { ...{ trees, setMode, BuilderFilters } }) : null;
};
SearchFilters.propTypes = {
  mode: import_prop_types.default.oneOf(["basic", "builder", "resultsOnly"])
};
var SearchFilters_default = (0, import_mobx_react.observer)(SearchFilters);
