var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var CheckableResultTable_exports = {};
__export(CheckableResultTable_exports, {
  default: () => CheckableResultTable_default
});
module.exports = __toCommonJS(CheckableResultTable_exports);
var import_react = __toESM(require("react"));
var import_fp = __toESM(require("lodash/fp.js"));
var import_futil = __toESM(require("futil"));
var import_react_recompose = require("react-recompose");
var import_mobx_react = require("mobx-react");
var import_schema = require("../utils/schema.js");
var import_hoc = require("../utils/hoc.js");
var import_theme = require("../utils/theme.js");
var import_ResultTable = __toESM(require("./ResultTable/index.js"));
var import_utils = require("./utils.js");
var import_react2 = require("../utils/react.js");
let Label = import_fp.default.flow(
  (0, import_react_recompose.setDisplayName)("Label"),
  import_mobx_react.observer,
  import_theme.withTheme
)(({ node, selected, getValue, theme }) => {
  let results = import_fp.default.toArray((0, import_schema.getResults)(node));
  let allChecked = import_fp.default.size(results) === import_fp.default.size(import_futil.default.view(selected));
  let checkAll = import_futil.default.sets(
    allChecked ? [] : import_fp.default.map(import_fp.default.flow(import_schema.getRecord, import_fp.default.iteratee(getValue)), results),
    selected
  );
  return /* @__PURE__ */ import_react.default.createElement(theme.Checkbox, { checked: allChecked, onChange: checkAll });
});
let CheckableResultTable = ({
  node,
  fields,
  selectedValues,
  onChange,
  getValue,
  theme,
  ...props
}) => /* @__PURE__ */ import_react.default.createElement(
  import_ResultTable.default,
  {
    fields: {
      _checkbox: import_fp.default.merge(
        {
          hideMenu: true,
          label: () => /* @__PURE__ */ import_react.default.createElement(
            Label,
            {
              ...{
                node,
                selected: [selectedValues, onChange],
                getValue,
                theme
              }
            }
          ),
          display: (x, y) => {
            let value = import_fp.default.iteratee(getValue)(y);
            return !import_fp.default.isNil(value) && /* @__PURE__ */ import_react.default.createElement(
              theme.Checkbox,
              {
                ...import_futil.default.domLens.checkboxValues(value, [
                  selectedValues,
                  onChange
                ])
              }
            );
          }
        },
        fields._checkbox
      ),
      ...import_fp.default.omit("_checkbox", fields)
    },
    ...props
  }
);
var CheckableResultTable_default = import_fp.default.flow(
  (0, import_react2.expandProp)("selected", import_utils.selectedBinding),
  import_hoc.contexturifyWithoutLoader
)(CheckableResultTable);
