var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var Date_exports = {};
__export(Date_exports, {
  default: () => Date_default
});
module.exports = __toCommonJS(Date_exports);
var import_react = __toESM(require("react"));
var import_greyVest = require("../greyVest/index.js");
var import_hoc = require("../utils/hoc.js");
var import_futil = __toESM(require("futil"));
var import_fp = __toESM(require("lodash/fp.js"));
var import_moment = __toESM(require("moment"));
let allRollingOpts = [
  { type: "all", range: "allDates" },
  { type: "all", range: "allPastDates" },
  { type: "all", range: "allFutureDates" },
  { type: "past", range: "last1Hour" },
  { type: "past", range: "last1Day" },
  { type: "past", range: "last3Days" },
  { type: "past", range: "last7Days" },
  { type: "past", range: "last30Days" },
  { type: "past", range: "last90Days" },
  { type: "past", range: "last180Days" },
  { type: "past", range: "last12Months" },
  { type: "past", range: "last15Months" },
  { type: "past", range: "last18Months" },
  { type: "past", range: "last24Months" },
  { type: "past", range: "last36Months" },
  { type: "past", range: "last48Months" },
  { type: "past", range: "last60Months" },
  { type: "past", range: "lastCalendarMonth" },
  { type: "past", range: "lastCalendarQuarter" },
  { type: "past", range: "lastCalendarYear" },
  { type: "present", range: "thisCalendarMonth" },
  { type: "present", range: "thisCalendarQuarter" },
  { type: "present", range: "thisCalendarYear" },
  { type: "future", range: "nextCalendarMonth" },
  { type: "future", range: "nextCalendarQuarter" },
  { type: "future", range: "nextCalendarYear" },
  { type: "future", range: "next30Days" },
  { type: "future", range: "next60Days" },
  { type: "future", range: "next90Days" },
  { type: "future", range: "next6Months" },
  { type: "future", range: "next12Months" },
  { type: "future", range: "next18Months" },
  { type: "future", range: "next24Months" },
  { type: "future", range: "next36Months" }
];
let endOfDay = (date) => date && (0, import_moment.default)(date).endOf("day").toDate();
let DateComponent = ({
  tree,
  node,
  excludeRollingRanges = [],
  theme: { DateInput, RadioList, Select }
}) => {
  let rollingOpts = import_fp.default.reject(
    (opt) => import_fp.default.includes(opt.type, excludeRollingRanges),
    allRollingOpts
  );
  return /* @__PURE__ */ import_react.default.createElement("div", { "data-path": node.path }, /* @__PURE__ */ import_react.default.createElement(
    RadioList,
    {
      options: import_futil.default.autoLabelOptions(["exact", "rolling"]),
      value: node.range !== "exact" ? "rolling" : "exact",
      style: { marginBottom: 10 },
      onChange: (value) => {
        tree.mutate(
          node.path,
          value === "exact" ? { range: "exact", from: null, to: null } : { range: "", from: null, to: null }
        );
      }
    }
  ), node.range === "exact" ? /* @__PURE__ */ import_react.default.createElement(import_greyVest.Flex, { style: { justifyContent: "space-between", alignItems: "center" } }, /* @__PURE__ */ import_react.default.createElement(
    DateInput,
    {
      value: node.from,
      onChange: (date) => tree.mutate(node.path, { range: "exact", from: date })
    }
  ), /* @__PURE__ */ import_react.default.createElement("div", null, "-"), /* @__PURE__ */ import_react.default.createElement(
    DateInput,
    {
      value: node.to,
      onChange: (date) => tree.mutate(node.path, { range: "exact", to: endOfDay(date) })
    }
  )) : /* @__PURE__ */ import_react.default.createElement(
    Select,
    {
      value: node.range,
      onChange: (e) => tree.mutate(node.path, {
        range: e.target.value,
        timezone: Intl.DateTimeFormat().resolvedOptions().timeZone
      }),
      options: import_futil.default.map(
        ({ range }) => ({
          label: import_fp.default.startCase(range),
          value: range,
          selected: node.range === range
        }),
        rollingOpts
      )
    }
  ));
};
var Date_default = (0, import_hoc.contexturifyWithoutLoader)(DateComponent);
