var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var KeywordGenerations_exports = {};
__export(KeywordGenerations_exports, {
  default: () => KeywordGenerations_default
});
module.exports = __toCommonJS(KeywordGenerations_exports);
var import_react = __toESM(require("react"));
var import_fp = __toESM(require("lodash/fp.js"));
var import_futil = __toESM(require("futil"));
var import_mobx_react = require("mobx-react");
var import_format = require("../../utils/format.js");
var import_utils = require("../TagsQuery/utils.js");
let keysToLower = import_fp.default.flow(import_fp.default.keys, import_fp.default.map(import_fp.default.toLower));
let addIcon = /* @__PURE__ */ import_react.default.createElement(
  "i",
  {
    className: "material-icons",
    style: { padding: "0px 2px", fontSize: "small" }
  },
  "add"
);
let BlankRemoveIcon = () => /* @__PURE__ */ import_react.default.createElement("div", { style: { padding: 3 } });
let tipStrings = [
  "Click the keyword generator icon again to regenerate new suggestions based on the keywords selected for your search.",
  "Click on a keyword to add it to your search.",
  "Enter a minimum of 3 keywords to start generating suggestions.",
  "Enter more than 3 keywords to improve the quality of the suggestions"
];
let KeywordGenerations = ({
  node,
  tree,
  Tag,
  generationsCollapsed,
  innerEdgeMargins = {},
  Loader
}) => {
  let [tips, setTips] = import_react.default.useState([...tipStrings]);
  import_react.default.useEffect(() => {
    import_futil.default.when(
      setTips((tips2) => [import_fp.default.last(tips2), ...import_fp.default.dropRight(1, tips2)]),
      import_futil.default.view(generationsCollapsed)
    );
  }, [generationsCollapsed]);
  return /* @__PURE__ */ import_react.default.createElement("div", { style: !import_futil.default.view(generationsCollapsed) ? {} : { display: "none" } }, /* @__PURE__ */ import_react.default.createElement("div", null, node.isStale && node.generateKeywords && import_fp.default.size(node.tags) <= 100 && /* @__PURE__ */ import_react.default.createElement(Loader, { style: { textAlign: "center" }, loading: true }, "Loading..."), !node.generateKeywords && import_fp.default.map((word) => /* @__PURE__ */ import_react.default.createElement(
    Tag,
    {
      tree,
      node,
      onClick: ({ value, label }) => tree.mutate(node.path, {
        tags: [...node.tags, (0, import_utils.convertWordToTag)(value, label)]
      }),
      AddIcon: addIcon,
      key: `tag-${word}`,
      RemoveIcon: BlankRemoveIcon,
      hoverColor: "#A9A9A9",
      tagStyle: {
        borderRadius: "3px",
        padding: "0px 0px",
        backgroundColor: "#E2E2E2"
      },
      value: `${word}`,
      label: `${word} (${(0, import_format.toNumber)(
        import_fp.default.get(`context.keywordGenerations.${word}`)(node)
      )})`
    }
  ))(
    import_fp.default.reject(
      import_fp.default.includes(import_fp.default, import_fp.default.map("word", node.tags)),
      keysToLower(node.context?.keywordGenerations)
    )
  ), import_fp.default.size(node.tags) > 100 && import_fp.default.size(node.context?.keywordGenerations) === 0 && "Keyword suggestions are limited once 100 or more keywords are present, please remove some keywords to generate suggestions."), /* @__PURE__ */ import_react.default.createElement(
    "div",
    {
      style: {
        ...!import_fp.default.isEmpty(innerEdgeMargins) && {
          marginRight: innerEdgeMargins.marginRight,
          marginLeft: innerEdgeMargins.marginLeft,
          marginBottom: innerEdgeMargins.marginBottom
        },
        backgroundColor: "#f5f5f5",
        marginTop: "12px",
        padding: "4px 12px",
        borderBottomRightRadius: 3,
        borderBottomLeftRadius: 3,
        display: "grid",
        gridTemplateColumns: "18px 15px fit-content(100%) 15px"
      }
    },
    /* @__PURE__ */ import_react.default.createElement(
      "i",
      {
        className: "material-icons",
        style: {
          margin: "auto 0",
          padding: "0px 2px",
          paddingTop: "1px",
          opacity: "0.5",
          fontSize: "small"
        }
      },
      "info"
    ),
    /* @__PURE__ */ import_react.default.createElement(
      "span",
      {
        onClick: () => setTips((tips2) => [...import_fp.default.tail(tips2), import_fp.default.head(tips2)])
      },
      /* @__PURE__ */ import_react.default.createElement(
        "i",
        {
          className: "material-icons",
          style: {
            margin: "auto 0",
            padding: "0px 2px",
            paddingTop: "1px",
            opacity: "0.5",
            fontSize: "small",
            cursor: "pointer"
          }
        },
        "chevron_left"
      )
    ),
    /* @__PURE__ */ import_react.default.createElement(
      "span",
      {
        style: {
          fontFamily: "Lato",
          fontSize: "12px",
          fontWeight: "normal",
          fontStretch: "normal",
          fontStyle: "italic",
          margin: "auto 0"
        }
      },
      "Tip: ",
      tips[0]
    ),
    /* @__PURE__ */ import_react.default.createElement(
      "span",
      {
        onClick: () => setTips((tips2) => [import_fp.default.last(tips2), ...import_fp.default.dropRight(1, tips2)])
      },
      /* @__PURE__ */ import_react.default.createElement(
        "i",
        {
          className: "material-icons",
          style: {
            margin: "auto 0",
            padding: "0px 2px",
            paddingTop: "1px",
            opacity: "0.5",
            fontSize: "small",
            cursor: "pointer"
          }
        },
        "chevron_right"
      )
    )
  ));
};
var KeywordGenerations_default = (0, import_mobx_react.observer)(KeywordGenerations);
