var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var ExpandableTagsQuery_exports = {};
__export(ExpandableTagsQuery_exports, {
  default: () => ExpandableTagsQuery_default
});
module.exports = __toCommonJS(ExpandableTagsQuery_exports);
var import_react = __toESM(require("react"));
var import_fp = __toESM(require("lodash/fp.js"));
var import_futil = __toESM(require("futil"));
var import_react_measure = require("react-measure");
var import_mobx = require("mobx");
var import_hoc = require("../../utils/hoc.js");
var import_ExpandArrow = __toESM(require("./ExpandArrow.js"));
var import_mobx_react = require("mobx-react");
var import_format = require("../../utils/format.js");
var import_TagActionsMenu = __toESM(require("../TagsQuery/TagActionsMenu.js"));
var import_greyVest = require("../../greyVest/index.js");
var import_utils = require("../TagsQuery/utils.js");
var import_ActionsMenu = __toESM(require("../TagsQuery/ActionsMenu.js"));
var import_react_use_outside_click = require("@chakra-ui/react-use-outside-click");
var import_keywordGenerations = require("contexture-util/keywordGenerations.js");
var import_KeywordGenerations = __toESM(require("./KeywordGenerations.js"));
var import_utils2 = require("../../greyVest/utils.js");
let innerHeightLimit = 40;
let isKeywordLightBulbOn = (tags) => (0, import_keywordGenerations.sanitizeTagInputs)(tags)?.length > 2;
let triggerKeywordGeneration = async (node, tree) => {
  await tree.mutate(node.path, { generateKeywords: true });
  tree.mutate(node.path, { generateKeywords: false });
};
let KeywordGenerationIcon = ({ strokeColor = "currentColor" }) => /* @__PURE__ */ import_react.default.createElement(
  "svg",
  {
    xmlns: "http://www.w3.org/2000/svg",
    className: "h-6 w-6",
    viewBox: "0 0 24 24",
    fill: "none",
    stroke: strokeColor,
    strokeWidth: "2"
  },
  /* @__PURE__ */ import_react.default.createElement("title", null, "Enter 3 keywords to generate keyword suggestions."),
  /* @__PURE__ */ import_react.default.createElement(
    "path",
    {
      strokeLinecap: "round",
      strokeLinejoin: "round",
      d: "M9.663 17h4.673M12 3v1m6.364 1.636l-.707.707M21 12h-1M4 12H3m3.343-5.657l-.707-.707m2.828 9.9a5 5 0 117.072 0l-.548.547A3.374 3.374 0 0014 18.469V19a2 2 0 11-4 0v-.531c0-.895-.356-1.754-.988-2.386l-.548-.547z"
    }
  )
);
let ExpandableTagsQuery = ({
  measureRef,
  contentRect,
  collapse,
  hasPopover,
  theme,
  tree,
  node,
  innerEdgeMargins = {},
  ...props
}) => {
  let generationsCollapsed = import_react.default.useState(true);
  let { marginRight, marginLeft } = innerEdgeMargins;
  let ref = import_react.default.useRef();
  (0, import_react_use_outside_click.useOutsideClick)({
    ref,
    handler: () => !hasPopover?.current && import_futil.default.on(generationsCollapsed)()
  });
  let showMoreKeywordsButton = import_futil.default.view(collapse) && contentRect.entry.height > innerHeightLimit && !!node.tags.length;
  return /* @__PURE__ */ import_react.default.createElement("div", { ref, onMouseUp: (e) => e.stopPropagation() }, /* @__PURE__ */ import_react.default.createElement("div", null, /* @__PURE__ */ import_react.default.createElement(
    "div",
    {
      style: {
        overflow: "hidden",
        maxHeight: import_futil.default.view(collapse) ? innerHeightLimit : ""
      }
    },
    /* @__PURE__ */ import_react.default.createElement("div", { ref: measureRef }, /* @__PURE__ */ import_react.default.createElement(
      TagsWrapper,
      {
        ...import_fp.default.omit("measure", props),
        tree,
        node,
        theme,
        hasPopover,
        generationsCollapsed
      }
    ))
  ), showMoreKeywordsButton && /* @__PURE__ */ import_react.default.createElement("div", { style: { minHeight: 10 } }, /* @__PURE__ */ import_react.default.createElement(import_ExpandArrow.default, { collapse, tagsLength: node.tags.length }))), !import_futil.default.view(generationsCollapsed) && /* @__PURE__ */ import_react.default.createElement(
    "hr",
    {
      style: {
        border: "1px solid #EBEBEB",
        ...!import_fp.default.isEmpty(innerEdgeMargins) && { marginLeft, marginRight },
        ...!import_futil.default.view(collapse) && { marginBottom: "10px" },
        ...showMoreKeywordsButton && { marginBottom: 20 }
      }
    }
  ), /* @__PURE__ */ import_react.default.createElement(
    import_KeywordGenerations.default,
    {
      node,
      tree,
      Tag: theme.Tag,
      generationsCollapsed,
      innerEdgeMargins,
      ...props
    }
  ));
};
let TagsWrapper = (0, import_mobx_react.observer)(
  ({
    tree,
    node,
    style,
    actionWrapper,
    onAddTag = import_fp.default.noop,
    onTagsDropped = import_fp.default.noop,
    popoverPosition = "bottom right",
    popoverArrow,
    popoverOffsetY,
    theme: { Icon, TagsInput, Tag, Popover },
    joinOptions,
    splitCommas = true,
    maxTags = 1e3,
    hasPopover,
    enableKeywordGenerations,
    generationsCollapsed,
    ...props
  }) => {
    let TagWithPopover = import_react.default.memo(
      (0, import_mobx_react.observer)((props2) => {
        let count = import_fp.default.get(["context", "tags", props2.value], node) ?? import_fp.default.get(["context", "keywordGenerations", props2.value], node) ?? (node.forceFilterOnly || node.updating ? void 0 : import_futil.default.when(
          import_fp.default.isNaN(),
          void 0,
          import_fp.default.get(`context.tags.${props2.value}`, node)
        ));
        let tagProps = {
          ...props2,
          ...!import_fp.default.isNil(count) && {
            label: `${props2.value} (${(0, import_format.toNumber)(count)})`
          }
        };
        return /* @__PURE__ */ import_react.default.createElement(
          Popover,
          {
            position: "right top",
            closeOnPopoverClick: false,
            trigger: /* @__PURE__ */ import_react.default.createElement(Tag, { ...tagProps }),
            onOpen: () => hasPopover.current = true,
            onClose: () => hasPopover.current = false
          },
          /* @__PURE__ */ import_react.default.createElement(
            import_TagActionsMenu.default,
            {
              tag: props2.value,
              ...{ node, tree },
              onChange: () => hasPopover.current = false
            }
          )
        );
      })
    );
    return /* @__PURE__ */ import_react.default.createElement(import_react.default.Fragment, null, /* @__PURE__ */ import_react.default.createElement(
      import_greyVest.Grid,
      {
        "data-path": node.path,
        rows: `${innerHeightLimit}px minmax(0, auto)`,
        columns: "1fr auto auto",
        style: { ...style, marginBottom: 10 }
      },
      /* @__PURE__ */ import_react.default.createElement(import_greyVest.GridItem, { height: 2, place: "center stretch" }, /* @__PURE__ */ import_react.default.createElement(
        TagsInput,
        {
          splitCommas,
          sanitizeTagFn: import_utils2.sanitizeQueryStringTag,
          maxTags,
          tags: node.tags?.length > 0 ? import_fp.default.map(import_utils.tagValueField, node.tags) : import_futil.default.on(generationsCollapsed)(),
          onTagsDropped,
          addTags: (addedTags) => {
            let addedTagObjects = import_fp.default.map(import_utils.convertWordToTag, addedTags);
            let tags = [...node.tags, ...addedTagObjects];
            if (import_fp.default.size(tags) > maxTags) {
              tags = import_fp.default.take(maxTags, tags);
              onTagsDropped(maxTags, tags);
            }
            tree.mutate(node.path, { tags });
            onAddTag(tags);
          },
          removeTag: (tag) => {
            tree.mutate(node.path, {
              tags: import_fp.default.reject({ [import_utils.tagValueField]: tag }, node.tags)
            });
            node.tags?.length <= 2 && import_futil.default.on(generationsCollapsed)();
          },
          tagStyle: (0, import_utils.getTagStyle)(node, import_utils.tagValueField),
          submit: tree.triggerUpdate,
          Tag: TagWithPopover,
          style: { flex: 1, border: 0 },
          ...props
        }
      )),
      /* @__PURE__ */ import_react.default.createElement(import_greyVest.GridItem, { place: "center" }, /* @__PURE__ */ import_react.default.createElement(
        import_greyVest.TextButton,
        {
          style: (
            // Show suggestion lightbulb if min of 3 non numeric tags exist,
            // including numbers ups the chance of producing bad suggestions
            {
              display: "flex",
              width: 32,
              strokeOpacity: 0.5,
              ...!enableKeywordGenerations && { display: "none" },
              ...isKeywordLightBulbOn(node.tags) && {
                strokeOpacity: 1
              }
            }
          ),
          onClick: async () => {
            if (!node.generateKeywords && isKeywordLightBulbOn(node.tags)) {
              let collapsedState = import_futil.default.view(generationsCollapsed);
              let context = (0, import_mobx.toJS)(node.context);
              import_futil.default.off(generationsCollapsed)();
              if (!collapsedState || import_fp.default.isEmpty(context.keywordGenerations) || import_fp.default.isEmpty(
                import_fp.default.difference(
                  import_fp.default.keys(context.keywordGenerations),
                  import_fp.default.keys(context.tags)
                )
              )) {
                await triggerKeywordGeneration(node, tree);
              }
            }
          }
        },
        /* @__PURE__ */ import_react.default.createElement(
          KeywordGenerationIcon,
          {
            strokeColor: isKeywordLightBulbOn(node.tags) ? "#0076de" : "currentColor"
          }
        )
      )),
      /* @__PURE__ */ import_react.default.createElement(import_greyVest.GridItem, { place: "center" }, /* @__PURE__ */ import_react.default.createElement(
        Popover,
        {
          style: { width: "auto" },
          position: popoverPosition,
          arrow: popoverArrow,
          offsetY: popoverOffsetY,
          closeOnPopoverClick: false,
          trigger: /* @__PURE__ */ import_react.default.createElement("div", { style: { display: "flex", justifyContent: "center" } }, /* @__PURE__ */ import_react.default.createElement(Icon, { icon: "TableColumnMenu" }))
        },
        (close) => /* @__PURE__ */ import_react.default.createElement(
          import_ActionsMenu.default,
          {
            ...{
              node,
              tree,
              close,
              actionWrapper,
              joinOptions
            }
          }
        )
      ))
    ));
  }
);
var ExpandableTagsQuery_default = import_fp.default.flow(
  import_hoc.contexturifyWithoutLoader,
  (0, import_react_measure.withContentRect)()
)(ExpandableTagsQuery);
