var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var Facet_exports = {};
__export(Facet_exports, {
  default: () => Facet_default
});
module.exports = __toCommonJS(Facet_exports);
var import_react = __toESM(require("react"));
var import_futil = __toESM(require("futil"));
var import_fp = __toESM(require("lodash/fp.js"));
var import_hoc = require("../utils/hoc.js");
var import_format = require("../utils/format.js");
var import_facet = require("../utils/facet.js");
let maxChecked = 500;
let warningCheck = 250;
let Facet = ({
  tree,
  node,
  hide = {
    selectAll: false,
    // Hide the initial "Select All" checkbox
    radioList: false,
    // Hide the Include/Exclude radio list
    facetFilter: false,
    // Hide the search box above the facet checkboxes
    counts: false
    // Hide the facet counts so only the labels are displayed
  },
  display = import_facet.displayFn,
  displayBlank = import_facet.displayBlankFn,
  formatCount = import_format.toNumber,
  theme: { RadioList }
}) => {
  let valuesChecked = import_fp.default.size(node.values);
  return /* @__PURE__ */ import_react.default.createElement("div", { className: "contexture-facet", "data-path": node.path }, valuesChecked > warningCheck && /* @__PURE__ */ import_react.default.createElement("span", null, "You have selected more than 250 items for this filter. Please consider using a different ", /* @__PURE__ */ import_react.default.createElement("b", null, "filter type"), " or contact support for more search options. You will not be able to select more than 500 items maximum."), !hide.radioList && /* @__PURE__ */ import_react.default.createElement(
    RadioList,
    {
      value: node.mode || "include",
      onChange: (mode) => tree.mutate(node.path, { mode }),
      options: import_futil.default.autoLabelOptions(["include", "exclude"])
    }
  ), !hide.facetFilter && /* @__PURE__ */ import_react.default.createElement(import_facet.FacetOptionsFilter, { tree, node }), !hide.selectAll && /* @__PURE__ */ import_react.default.createElement(import_facet.SelectAll, { node, tree, maxChecked }), /* @__PURE__ */ import_react.default.createElement(
    import_facet.FacetCheckboxList,
    {
      tree,
      node,
      hide,
      display,
      displayBlank,
      formatCount
    }
  ), /* @__PURE__ */ import_react.default.createElement(import_facet.Cardinality, { ...{ node, tree } }));
};
var Facet_default = (0, import_hoc.contexturify)(Facet);
