var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var Header_exports = {};
__export(Header_exports, {
  default: () => Header_default
});
module.exports = __toCommonJS(Header_exports);
var import_react = __toESM(require("react"));
var import_fp = __toESM(require("lodash/fp.js"));
var import_futil = __toESM(require("futil"));
var import_mobx_react = require("mobx-react");
var import_greyVest = require("../../greyVest/index.js");
var import_theme = require("../../utils/theme.js");
const moveColumn = (mutate, computeNextIndex, field, visibleFields, includes) => {
  let visibleFieldIndex = import_fp.default.findIndex({ field }, visibleFields);
  let nextField = import_fp.default.flow(
    import_fp.default.nth(computeNextIndex(visibleFieldIndex)),
    import_fp.default.get("field")
  )(visibleFields);
  mutate({
    include: import_futil.default.moveIndex(
      import_fp.default.indexOf(field, includes),
      import_fp.default.indexOf(nextField, includes),
      includes
    )
  });
};
let popoverStyle = {
  userSelect: "none",
  width: "auto"
};
let DefaultHeaderCell = (0, import_theme.withTheme)(({ children, theme: { Th }, ...props }) => /* @__PURE__ */ import_react.default.createElement(Th, { ...props }, /* @__PURE__ */ import_react.default.createElement(import_greyVest.Flex, { style: { display: "inline-flex", alignItems: "center" } }, children)));
let Header = ({
  field: fieldSchema,
  includes,
  addOptions,
  addFilter,
  tree,
  node,
  mutate,
  criteria,
  mapNodeToProps,
  fields,
  visibleFields,
  isStickyColumn,
  isLastColumn,
  theme: {
    Button,
    DropdownItem,
    Icon,
    Popover,
    Modal,
    NestedPicker,
    UnmappedNodeComponent
  }
}) => {
  let adding = import_react.default.useState(false);
  let {
    disableFilter,
    disableSort,
    field,
    sortField = field,
    label,
    hideRemoveColumn,
    hideMenu,
    typeDefault
  } = fieldSchema;
  let HeaderCell = fieldSchema.HeaderCell || DefaultHeaderCell;
  let filterNode = criteria && import_fp.default.find({ field }, import_fp.default.getOr([], "children", tree.getNode(criteria)));
  let filtering = import_react.default.useState(!!filterNode && !import_fp.default.get("paused", filterNode));
  let filter = () => {
    if (!filterNode)
      addFilter(field);
    filterNode = criteria && import_fp.default.find({ field }, import_fp.default.getOr([], "children", tree.getNode(criteria)));
    tree.mutate(filterNode.path, { paused: false });
    import_futil.default.flip(filtering)();
  };
  let Label = label;
  let { className, style, ...headerCellProps } = fieldSchema.headerCellProps ?? {};
  return /* @__PURE__ */ import_react.default.createElement(
    HeaderCell,
    {
      className: `${isStickyColumn ? "sticky-column-header" : ""}
        ${import_fp.default.get("hasValue", filterNode) ? "active-filter" : ""} ${className}`,
      style: {
        cursor: hideMenu ? "default" : "pointer",
        left: isStickyColumn ? 0 : "",
        ...style
      },
      ...headerCellProps
    },
    import_fp.default.isFunction(label) ? /* @__PURE__ */ import_react.default.createElement(Label, null) : label,
    " ",
    field === node.sortField && /* @__PURE__ */ import_react.default.createElement(
      Icon,
      {
        icon: node.sortDir === "asc" ? "SortAscending" : "SortDescending"
      }
    ),
    /* @__PURE__ */ import_react.default.createElement(
      Popover,
      {
        trigger: hideMenu ? null : /* @__PURE__ */ import_react.default.createElement(Icon, { icon: "TableColumnMenu" }),
        position: `bottom ${isLastColumn ? "right" : "center"}`,
        closeOnPopoverClick: false,
        style: popoverStyle
      },
      !disableSort && /* @__PURE__ */ import_react.default.createElement(import_react.default.Fragment, null, /* @__PURE__ */ import_react.default.createElement(DropdownItem, { onClick: () => mutate({ sortField, sortDir: "asc" }) }, /* @__PURE__ */ import_react.default.createElement(Icon, { icon: "SortAscending" }), "Sort Ascending"), /* @__PURE__ */ import_react.default.createElement(
        DropdownItem,
        {
          onClick: () => mutate({ sortField, sortDir: "desc" })
        },
        /* @__PURE__ */ import_react.default.createElement(Icon, { icon: "SortDescending" }),
        "Sort Descending"
      )),
      /* @__PURE__ */ import_react.default.createElement(
        DropdownItem,
        {
          onClick: () => moveColumn(mutate, (i) => i - 1, field, visibleFields, includes)
        },
        /* @__PURE__ */ import_react.default.createElement(Icon, { icon: "MoveLeft" }),
        "Move Left"
      ),
      /* @__PURE__ */ import_react.default.createElement(
        DropdownItem,
        {
          onClick: () => moveColumn(mutate, (i) => i + 1, field, visibleFields, includes)
        },
        /* @__PURE__ */ import_react.default.createElement(Icon, { icon: "MoveRight" }),
        "Move Right"
      ),
      !hideRemoveColumn && /* @__PURE__ */ import_react.default.createElement(
        DropdownItem,
        {
          onClick: () => mutate({ include: import_fp.default.without([field], includes) })
        },
        /* @__PURE__ */ import_react.default.createElement(Icon, { icon: "RemoveColumn" }),
        "Remove Column"
      ),
      !!addOptions.length && /* @__PURE__ */ import_react.default.createElement(DropdownItem, { onClick: import_futil.default.on(adding) }, /* @__PURE__ */ import_react.default.createElement(Icon, { icon: "AddColumn" }), "Add Column"),
      criteria && (typeDefault || filterNode) && !disableFilter && /* @__PURE__ */ import_react.default.createElement("div", null, /* @__PURE__ */ import_react.default.createElement(DropdownItem, { onClick: filter }, /* @__PURE__ */ import_react.default.createElement(
        Icon,
        {
          icon: filterNode ? import_futil.default.view(filtering) ? "FilterCollapse" : "FilterExpand" : "FilterAdd"
        }
      ), "Filter"), import_futil.default.view(filtering) && filterNode && !filterNode.paused && /* @__PURE__ */ import_react.default.createElement(import_react.default.Fragment, null, /* @__PURE__ */ import_react.default.createElement(
        import_greyVest.Dynamic,
        {
          ...{
            component: UnmappedNodeComponent,
            tree,
            path: import_fp.default.toArray(filterNode.path),
            ...mapNodeToProps(filterNode, fields)
          }
        }
      ), tree.disableAutoUpdate && node.markedForUpdate && /* @__PURE__ */ import_react.default.createElement(
        Button,
        {
          primary: true,
          style: { width: "100%" },
          onClick: (e) => {
            e.stopPropagation();
            tree.triggerUpdate();
          }
        },
        "Search"
      ))),
      /* @__PURE__ */ import_react.default.createElement(Modal, { open: adding }, /* @__PURE__ */ import_react.default.createElement(
        NestedPicker,
        {
          itemType: "column",
          options: addOptions,
          onChange: (selectedFields) => {
            import_fp.default.each(({ field: addedField }) => {
              let index = includes.indexOf(field);
              if (index >= 0 && addedField) {
                includes.splice(index + 1, 0, addedField);
                mutate({ include: includes });
              }
            }, selectedFields);
            import_futil.default.off(adding)();
          }
        }
      ))
    )
  );
};
var Header_default = import_fp.default.flow(import_mobx_react.observer, import_theme.withTheme)(Header);
