var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var TableBody_exports = {};
__export(TableBody_exports, {
  default: () => TableBody_default
});
module.exports = __toCommonJS(TableBody_exports);
var import_react = __toESM(require("react"));
var import_fp = __toESM(require("lodash/fp.js"));
var import_mobx_react = require("mobx-react");
var import_schema = require("../../utils/schema.js");
var import_format = require("../../utils/format.js");
var import_theme = require("../../utils/theme.js");
var import_greyVest = require("../../greyVest/index.js");
let displayCell = ({ display, value, record, result, ...props }) => result.isBlank ? (0, import_format.blankResult)(display)(value, record, props) : display(value, record, props);
let TableBody = ({
  node,
  tree,
  visibleFields,
  fields,
  hiddenFields,
  getRowKey = import_fp.default.get("_id"),
  blankRows,
  pageSize,
  stickyColumn,
  theme: { Tbody, Tr, Td, Loader = import_greyVest.StripedLoader },
  Row = Tr,
  NoResultsComponent,
  IntroComponent,
  defaultDisplay = displayCell
}) => {
  let results = blankRows ? (0, import_format.addBlankRows)((0, import_schema.getResults)(node), pageSize, "_id") : (0, import_schema.getResults)(node);
  let hasResults = import_fp.default.get("length", results);
  let showLoader = node.updating;
  let showIntro = !showLoader && !hasResults && !node.lastUpdateTime;
  let showNoResults = !showLoader && !showIntro && !hasResults;
  return /* @__PURE__ */ import_react.default.createElement(import_react.default.Fragment, null, /* @__PURE__ */ import_react.default.createElement(
    Tbody,
    {
      style: {
        display: showIntro || showNoResults ? "none" : ""
      }
    },
    !import_fp.default.isEmpty(results) && import_fp.default.map(
      (x) => /* @__PURE__ */ import_react.default.createElement(
        Row,
        {
          key: getRowKey(x),
          record: (0, import_schema.getRecord)(x),
          ...{ fields, visibleFields, hiddenFields }
        },
        import_fp.default.map(
          ({
            field,
            display = (x2) => x2,
            Cell = Td,
            cellProps: { className, style, ...cellProps } = {}
          }) => /* @__PURE__ */ import_react.default.createElement(
            Cell,
            {
              key: field,
              className: `${field === stickyColumn ? "sticky-column" : ""} ${className}`,
              style: {
                position: field === stickyColumn ? "sticky" : "",
                left: field === stickyColumn ? 0 : "",
                ...style
              },
              ...cellProps
            },
            defaultDisplay({
              display,
              value: import_fp.default.get(field, (0, import_schema.getRecord)(x)),
              record: (0, import_schema.getRecord)(x),
              result: x,
              tree,
              node
            })
          ),
          visibleFields
        )
      ),
      results
    )
  ), /* @__PURE__ */ import_react.default.createElement(
    Tbody,
    {
      style: {
        display: showIntro || showLoader || showNoResults ? "" : "none"
      }
    },
    /* @__PURE__ */ import_react.default.createElement(Tr, null, /* @__PURE__ */ import_react.default.createElement(Td, { colSpan: visibleFields.length, style: { padding: 0 } }, /* @__PURE__ */ import_react.default.createElement(Loader, { loading: showLoader }, (showLoader || showIntro) && IntroComponent, showNoResults && NoResultsComponent)))
  ));
};
var TableBody_default = import_fp.default.flow(import_mobx_react.observer, import_theme.withTheme)(TableBody);
