var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var ResultTable_exports = {};
__export(ResultTable_exports, {
  default: () => ResultTable_default
});
module.exports = __toCommonJS(ResultTable_exports);
var import_react = __toESM(require("react"));
var import_fp = __toESM(require("lodash/fp.js"));
var import_futil = __toESM(require("futil"));
var import_fields = require("../../utils/fields.js");
var import_hoc = require("../../utils/hoc.js");
var import_schema = require("../../utils/schema.js");
var import_search = require("../../utils/search.js");
var import_Header = __toESM(require("./Header.js"));
var import_TableBody = __toESM(require("./TableBody.js"));
var import_ResultTableFooter = __toESM(require("./ResultTableFooter.js"));
var import_theme = require("../../utils/theme.js");
let getIncludes = (schema, node) => import_futil.default.when(import_fp.default.isEmpty, import_fp.default.map("field", schema))(node.include);
let DefaultRow = (0, import_theme.withTheme)(({ theme: { Tr = "tr" }, ...props }) => /* @__PURE__ */ import_react.default.createElement(
  Tr,
  {
    ...import_fp.default.omit(["record", "fields", "visibleFields", "hiddenFields"], props)
  }
));
let ResultTable = ({
  fields,
  infer,
  path,
  criteria,
  node = {},
  tree,
  defaultDisplay,
  NoResultsComponent = "No Results Found",
  IntroComponent = null,
  // Initial component to be shown instead of the grid when no data has been loaded
  Row = DefaultRow,
  // accept a custom Row component so we can do fancy expansion things
  getRowKey,
  // allow passing a custom function to generate unique row key
  mapNodeToProps = () => ({}),
  pageSizeOptions,
  // an array of options to set the # of rows per page (default [20, 50, 100, 250])
  limitedResults,
  stickyColumn,
  hideFooter,
  footerStyle,
  theme
}) => {
  const { Table, Thead, Tr, Th } = theme;
  if (import_fp.default.isEmpty(fields) && !infer)
    throw new Error("Fields are empty");
  let mutate = tree.mutate(path);
  let resultsLength = import_futil.default.cascade(
    ["context.response.results.length", "context.results.length"],
    node
  );
  let totalRecords = import_futil.default.cascade(
    ["context.response.totalRecords", "context.totalRecords"],
    node
  );
  let blankRows = limitedResults && resultsLength < node.pageSize && totalRecords > resultsLength;
  let schema = import_fp.default.flow(
    import_fp.default.merge(infer && (0, import_schema.inferSchema)(node)),
    import_schema.applyDefaults,
    import_fp.default.values,
    import_fp.default.orderBy("order", "desc")
  )(fields);
  let includes = getIncludes(schema, node);
  let isIncluded = (x) => import_fp.default.includes(x.field, includes);
  let visibleFields = import_fp.default.flow(
    import_fp.default.map((field) => import_fp.default.find({ field }, schema)),
    import_fp.default.compact
  )(includes);
  let hiddenFields = import_fp.default.reject(isIncluded, schema);
  let headerProps = {
    mapNodeToProps,
    fields,
    visibleFields,
    includes,
    addOptions: (0, import_fields.fieldsToOptions)(hiddenFields),
    addFilter: (field) => tree.add(criteria, (0, import_search.newNodeFromField)({ field, fields })),
    tree,
    node,
    mutate,
    criteria,
    theme
  };
  let columnGroupsHeight = import_fp.default.flow(
    import_fp.default.map("fieldGroup.length"),
    import_fp.default.max
  )(visibleFields);
  let columnGroups = import_fp.default.reduce(
    (columnGroups2, { fieldGroup, headerCellProps, HeaderCell, HeaderGroup }) => {
      for (let i = 0; i < columnGroupsHeight; i++) {
        let groupRow = columnGroups2[i] || (columnGroups2[i] = []);
        let groupName = import_fp.default.getOr("", i, fieldGroup);
        let lastGroup = import_fp.default.last(groupRow);
        if (import_fp.default.get("groupName", lastGroup) === groupName) {
          lastGroup.colspan++;
          lastGroup.HeaderCell = HeaderCell;
        } else
          groupRow.push({
            groupName,
            colspan: 1,
            headerCellProps,
            HeaderCell,
            HeaderGroup
          });
      }
      return columnGroups2;
    },
    [],
    visibleFields
  );
  return /* @__PURE__ */ import_react.default.createElement(import_react.default.Fragment, null, /* @__PURE__ */ import_react.default.createElement(Table, { "data-path": node.path }, /* @__PURE__ */ import_react.default.createElement(Thead, null, import_futil.default.mapIndexed(
    (columnGroupRow, i) => /* @__PURE__ */ import_react.default.createElement(Tr, { key: i }, import_futil.default.mapIndexed(
      ({
        groupName,
        colspan,
        headerCellProps,
        HeaderCell = Th,
        HeaderGroup
      }, j) => /* @__PURE__ */ import_react.default.createElement(HeaderCell, { key: j, colSpan: colspan, ...headerCellProps }, HeaderGroup ? /* @__PURE__ */ import_react.default.createElement(HeaderGroup, null, groupName) : groupName),
      columnGroupRow
    )),
    columnGroups
  ), /* @__PURE__ */ import_react.default.createElement(Tr, null, import_futil.default.mapIndexed(
    (x, i) => /* @__PURE__ */ import_react.default.createElement(
      import_Header.default,
      {
        key: x.field,
        field: x,
        isLastColumn: i === visibleFields.length - 1,
        isStickyColumn: stickyColumn && x.field === stickyColumn,
        ...headerProps
      }
    ),
    visibleFields
  ))), /* @__PURE__ */ import_react.default.createElement(
    import_TableBody.default,
    {
      ...{
        node,
        tree,
        fields,
        visibleFields,
        hiddenFields,
        schema,
        Row,
        getRowKey,
        blankRows,
        pageSize: Math.min(node.pageSize, totalRecords),
        stickyColumn,
        NoResultsComponent,
        IntroComponent,
        defaultDisplay
      }
    }
  )), !hideFooter && node.pageSize > 0 && /* @__PURE__ */ import_react.default.createElement(
    import_ResultTableFooter.default,
    {
      ...{
        tree,
        node,
        path,
        pageSizeOptions,
        disabled: blankRows,
        style: footerStyle
      }
    }
  ));
};
var ResultTable_default = (0, import_hoc.contexturifyWithoutLoader)(ResultTable);
