var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var TagActionsMenu_exports = {};
__export(TagActionsMenu_exports, {
  default: () => TagActionsMenu_default
});
module.exports = __toCommonJS(TagActionsMenu_exports);
var import_react = __toESM(require("react"));
var import_fp = __toESM(require("lodash/fp.js"));
var import_futil = __toESM(require("futil"));
var import_mobx_react = require("mobx-react");
var import_theme = require("../../utils/theme.js");
var import_utils = require("./utils.js");
let TagActionsMenu = ({
  tag,
  node,
  tree,
  onChange,
  theme: { Button, Checkbox, RadioList }
}) => {
  let tagInstance = (0, import_utils.getTag)(tag, node);
  return /* @__PURE__ */ import_react.default.createElement(
    "div",
    {
      className: "tags-query-tag-actions-menu",
      style: { minWidth: 100, padding: 10 }
    },
    /* @__PURE__ */ import_react.default.createElement("div", null, import_fp.default.startCase(import_utils.tagTerm), ":", " ", /* @__PURE__ */ import_react.default.createElement("span", { className: "filter-field-label" }, tag)),
    import_fp.default.includes(" ", tag) && /* @__PURE__ */ import_react.default.createElement("div", { style: { margin: "10px 0" } }, /* @__PURE__ */ import_react.default.createElement(
      RadioList,
      {
        options: import_futil.default.autoLabelOptions(["fuzzy", "exact"]),
        value: tagInstance.distance ? "fuzzy" : "exact",
        onChange: (value) => {
          tagInstance.distance = value === "fuzzy" ? 3 : 0;
          tree.mutate(node.path, { tags: [...node.tags] });
          import_futil.default.maybeCall(onChange);
        }
      }
    ), /* @__PURE__ */ import_react.default.createElement(
      Button,
      {
        onClick: () => {
          tree.mutate(node.path, {
            tags: import_fp.default.map((tag2) => {
              if (import_fp.default.includes(" ", tag2[import_utils.tagValueField]))
                tag2.distance = tagInstance.distance;
              return tag2;
            }, node.tags)
          });
          import_futil.default.maybeCall(onChange);
        }
      },
      "Apply to all ",
      import_utils.tagTerm,
      "s"
    )),
    /* @__PURE__ */ import_react.default.createElement("label", { className: "labeled-checkbox", style: { marginTop: 15 } }, /* @__PURE__ */ import_react.default.createElement(
      Checkbox,
      {
        checked: tagInstance.onlyShowTheseResults,
        onChange: (e) => {
          tagInstance.onlyShowTheseResults = e.target.checked;
          tree.mutate(node.path, { tags: [...node.tags] });
          import_futil.default.maybeCall(onChange);
        }
      }
    ), /* @__PURE__ */ import_react.default.createElement("span", null, "Only view this ", import_utils.tagTerm))
  );
};
var TagActionsMenu_default = import_fp.default.flow(import_mobx_react.observer, import_theme.withTheme)(TagActionsMenu);
