var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var TagsQuerySearchBar_exports = {};
__export(TagsQuerySearchBar_exports, {
  default: () => TagsQuerySearchBar_default
});
module.exports = __toCommonJS(TagsQuerySearchBar_exports);
var import_react = __toESM(require("react"));
var import_futil = __toESM(require("futil"));
var import_fp = __toESM(require("lodash/fp.js"));
var import_mobx_react = require("mobx-react");
var import_react_use_outside_click = require("@chakra-ui/react-use-outside-click");
var import_hoc = require("../utils/hoc.js");
var import_greyVest = require("../greyVest/index.js");
var import_ExpandableTagsInput = __toESM(require("../greyVest/ExpandableTagsInput.js"));
var import_ExpandableTagsQuery = __toESM(require("./ExpandableTagsQuery/index.js"));
let searchBarStyle = {
  overflow: "visible"
  // for the search button animation
};
let searchBarBoxStyle = {
  padding: "8px 10px",
  flex: 1,
  borderBottomRightRadius: "3px"
};
let innerEdgeMargins = {
  marginRight: "-10px",
  marginLeft: "-10px",
  marginTop: "-8px",
  marginBottom: "-8px"
};
let inputStyle = {
  border: "none"
};
let buttonStyle = {
  boxShadow: "0 2px 10px 0 rgba(39, 44, 65, 0.1)",
  fontSize: 18,
  maxHeight: 56
};
let AnimatedButton = ({ disabled, style, className, ...props }) => /* @__PURE__ */ import_react.default.createElement(
  import_greyVest.Button,
  {
    className: `${disabled ? "disabled" : "animated pulse infinite"} ${className || ""}`,
    style: {
      ...style,
      ...disabled ? { backgroundColor: "#80BBEF" } : {},
      animationDuration: "500ms"
    },
    primary: true,
    ...props
  }
);
let SearchButton = (0, import_mobx_react.observer)(({ tree, searchButtonProps }) => /* @__PURE__ */ import_react.default.createElement(
  AnimatedButton,
  {
    disabled: !tree?.tree?.markedForUpdate,
    onClick: tree.triggerUpdate,
    style: buttonStyle,
    ...searchButtonProps
  },
  "Search"
));
let SearchBar = ({
  tree,
  node,
  actionWrapper,
  searchButtonProps,
  tagsQueryProps,
  enableKeywordGenerations
}) => {
  let collapse = import_react.default.useState(true);
  let ref = import_react.default.useRef();
  let hasPopover = import_react.default.useRef(false);
  (0, import_react_use_outside_click.useOutsideClick)({
    ref,
    handler: () => !hasPopover.current && import_futil.default.on(collapse)()
  });
  return /* @__PURE__ */ import_react.default.createElement(
    import_greyVest.ButtonGroup,
    {
      ref,
      "data-path": node.path,
      style: searchBarStyle,
      onMouseUp: (e) => {
        e.stopPropagation();
      }
    },
    /* @__PURE__ */ import_react.default.createElement(import_greyVest.Box, { style: searchBarBoxStyle, onClick: import_futil.default.off(collapse) }, /* @__PURE__ */ import_react.default.createElement(
      import_ExpandableTagsQuery.default,
      {
        ...{
          tree,
          node,
          collapse,
          hasPopover,
          actionWrapper,
          enableKeywordGenerations,
          innerEdgeMargins
        },
        onAddTag: import_futil.default.off(collapse),
        Loader: ({ children, ...props }) => /* @__PURE__ */ import_react.default.createElement(import_greyVest.StripedLoader, { ...props }, children),
        style: inputStyle,
        theme: {
          TagsInput: import_futil.default.view(collapse) && !import_fp.default.isEmpty(node.tags) ? import_ExpandableTagsInput.Tags : import_ExpandableTagsInput.default
        },
        autoFocus: !hasPopover.current,
        ...tagsQueryProps
      }
    )),
    tree.disableAutoUpdate && /* @__PURE__ */ import_react.default.createElement(SearchButton, { tree, searchButtonProps })
  );
};
var TagsQuerySearchBar_default = import_fp.default.flow(import_mobx_react.observer, import_hoc.withNode)(SearchBar);
