var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var TagsText_exports = {};
__export(TagsText_exports, {
  default: () => TagsText_default
});
module.exports = __toCommonJS(TagsText_exports);
var import_react = __toESM(require("react"));
var import_fp = __toESM(require("lodash/fp.js"));
var import_futil = __toESM(require("futil"));
var import_hoc = require("../utils/hoc.js");
var import_generic = require("../styles/generic.js");
var import_TagsJoinPicker = __toESM(require("./TagsJoinPicker.js"));
var import_Flex = __toESM(require("../greyVest/Flex.js"));
let operatorOptions = import_futil.default.autoLabelOptions([
  { value: "containsWord", label: "Field Contains" },
  { value: "wordStartsWith", label: "Word Starts With" },
  { value: "wordEndsWith", label: "Word Ends With" },
  { value: "containsExact", label: "Word Is Exactly" },
  { value: "startsWith", label: "Field Starts With" },
  { value: "endsWith", label: "Field Ends With" },
  { value: "is", label: "Field Is Exactly" }
  // { value: 'isNot', label: 'Is Not' },
  // { value: 'contains', label: 'Contains'},
  // { value: 'doesNotContain', label: 'Does Not Contain'}
]);
let Text = ({
  tree,
  node,
  placeholder,
  theme: { Select, TagsInput, Popover, Icon }
}) => /* @__PURE__ */ import_react.default.createElement("div", { className: "contexture-text" }, /* @__PURE__ */ import_react.default.createElement(
  Select,
  {
    value: node.operator,
    onChange: (e) => tree.mutate(node.path, { operator: e.target.value }),
    options: operatorOptions
  }
), /* @__PURE__ */ import_react.default.createElement(import_Flex.default, { className: "tags-query" }, /* @__PURE__ */ import_react.default.createElement(
  TagsInput,
  {
    splitCommas: true,
    tags: node.values,
    addTags: (tags) => {
      tree.mutate(node.path, { values: [...node.values, ...tags] });
    },
    removeTag: (tag) => {
      tree.mutate(node.path, {
        values: import_fp.default.without([tag], node.values)
      });
    },
    tagStyle: (0, import_generic.bgJoin)((0, import_TagsJoinPicker.tagToGroupJoin)(node.join)),
    submit: tree.triggerUpdate,
    placeholder,
    style: { flex: 1, border: 0 }
  }
), /* @__PURE__ */ import_react.default.createElement("div", { style: { paddingTop: 4 } }, /* @__PURE__ */ import_react.default.createElement(
  Popover,
  {
    trigger: /* @__PURE__ */ import_react.default.createElement("div", null, /* @__PURE__ */ import_react.default.createElement(Icon, { icon: "TableColumnMenu" })),
    position: "bottom right",
    closeOnPopoverClick: false,
    style: { width: 240 }
  },
  /* @__PURE__ */ import_react.default.createElement(import_TagsJoinPicker.default, { node, tree })
))));
var TagsText_default = (0, import_hoc.contexturify)(Text);
