var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var TermsStatsTable_exports = {};
__export(TermsStatsTable_exports, {
  default: () => TermsStatsTable_default
});
module.exports = __toCommonJS(TermsStatsTable_exports);
var import_fp = __toESM(require("lodash/fp.js"));
var import_futil = __toESM(require("futil"));
var import_react = __toESM(require("react"));
var import_mobx_react = require("mobx-react");
var import_hoc = require("../utils/hoc.js");
var import_theme = require("../utils/theme.js");
var import_greyVest = require("../greyVest/index.js");
var import_react_recompose = require("react-recompose");
let toolBarStyle = { justifyContent: "space-between", alignItems: "center" };
let SimpleLabel = ({ text }) => /* @__PURE__ */ import_react.default.createElement("label", { style: { paddingRight: "5px" } }, text);
let SimpleFilter = import_fp.default.flow(
  (0, import_react_recompose.setDisplayName)("SimpleFilter"),
  import_mobx_react.observer,
  import_theme.withTheme
)(({ theme: { TextInput }, ...props }) => /* @__PURE__ */ import_react.default.createElement(import_greyVest.Flex, { style: { ...toolBarStyle, width: "75%" } }, /* @__PURE__ */ import_react.default.createElement(SimpleLabel, { text: "Filter:" }), /* @__PURE__ */ import_react.default.createElement(TextInput, { ...props })));
let SelectSize = import_fp.default.flow(
  (0, import_react_recompose.setDisplayName)("SelectSize"),
  import_mobx_react.observer,
  import_theme.withTheme
)(
  ({
    node,
    tree,
    options = [10, 25, 50, 100, 500, 1e3],
    theme: { Select }
  }) => /* @__PURE__ */ import_react.default.createElement(import_greyVest.Flex, { style: { marginLeft: 12, ...toolBarStyle } }, /* @__PURE__ */ import_react.default.createElement(SimpleLabel, { text: "Size:" }), /* @__PURE__ */ import_react.default.createElement(
    Select,
    {
      onChange: (e) => {
        tree.mutate(node.path, { size: e.target.value });
      },
      value: import_fp.default.getOr(25, "size", node),
      placeholder: null,
      style: { width: "100px" },
      options: import_fp.default.map((x) => ({ value: x, label: x }), options)
    }
  ))
);
let TermsStatsTable = ({
  node,
  criteria,
  criteriaField,
  criteriaFieldLabel = "",
  criteriaGetValue = import_fp.default.identity,
  tree,
  children,
  sizeOptions,
  limitedResults,
  theme: { Button },
  ...props
}) => /* @__PURE__ */ import_react.default.createElement("div", null, /* @__PURE__ */ import_react.default.createElement(import_greyVest.Flex, { style: { ...toolBarStyle, margin: "0 8px" } }, /* @__PURE__ */ import_react.default.createElement(SimpleFilter, { ...import_futil.default.domLens.value(tree.lens(node.path, "filter")) }), /* @__PURE__ */ import_react.default.createElement(SelectSize, { node, tree, options: sizeOptions })), /* @__PURE__ */ import_react.default.createElement(
  import_greyVest.ExpandableTable,
  {
    ...{
      ...props,
      children: criteria ? [
        ...import_fp.default.compact(children),
        /* @__PURE__ */ import_react.default.createElement(
          import_greyVest.Column,
          {
            key: "checkbox",
            label: criteriaFieldLabel,
            expand: {
              display: (value, record) => /* @__PURE__ */ import_react.default.createElement("div", null, /* @__PURE__ */ import_react.default.createElement(
                Button,
                {
                  onClick: async () => {
                    let field = criteriaField || node.key_field || node.groupField;
                    let filter = criteria && import_fp.default.find({ field }, tree.getNode(criteria).children);
                    if (!filter || import_fp.default.get("mode", filter) === "exclude") {
                      await tree.add(criteria, {
                        field,
                        type: "facet"
                      });
                      filter = import_fp.default.findLast(
                        { field },
                        tree.getNode(criteria).children
                      );
                    }
                    await tree.mutate(filter.path, {
                      mode: "include",
                      values: import_fp.default.uniq([
                        ...import_fp.default.getOr([], "values", filter),
                        criteriaGetValue(record.key)
                      ])
                    });
                  }
                },
                "Add as Filter"
              ))
            }
          }
        )
      ] : import_fp.default.compact(children)
    },
    data: node.context?.terms ?? node.context?.results,
    sortField: node.order,
    sortDir: node.sortDir,
    columnSort: (column) => {
      if (column.field !== "key" && column.enableSort) {
        tree.mutate(node.path, {
          order: column.field,
          sortDir: column.sortDir
        });
      }
    },
    blankRows: limitedResults,
    pageSize: node.size
  }
));
var TermsStatsTable_default = (0, import_hoc.contexturify)(TermsStatsTable);
