var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var BarChart_exports = {};
__export(BarChart_exports, {
  default: () => BarChart_default
});
module.exports = __toCommonJS(BarChart_exports);
var import_react = __toESM(require("react"));
var import_fp = __toESM(require("lodash/fp.js"));
var import_mobx_react = require("mobx-react");
var import_Flex = __toESM(require("./Flex.js"));
let YAxis = ({ height, borderColor, min, max }) => /* @__PURE__ */ import_react.default.createElement("div", null, /* @__PURE__ */ import_react.default.createElement(
  "div",
  {
    key: "legend",
    style: {
      height,
      margin: "0 5px",
      display: "flex",
      flexDirection: "column",
      justifyContent: "space-between",
      borderRight: `solid 1px ${borderColor()}`,
      padding: "5px"
    }
  },
  /* @__PURE__ */ import_react.default.createElement(
    "div",
    {
      style: {
        borderTop: `solid 1px ${borderColor()}`,
        textAlign: "right"
      }
    },
    max
  ),
  /* @__PURE__ */ import_react.default.createElement(
    "div",
    {
      style: {
        borderBottom: `solid 1px ${borderColor()}`,
        textAlign: "right"
      }
    },
    min
  )
), /* @__PURE__ */ import_react.default.createElement("div", { style: { padding: "5px" } }, "\xA0"));
let BarChart = ({
  data,
  valueField,
  categoryField,
  background = () => "#ccc",
  height = 100,
  format = import_fp.default.identity,
  gutter = 5,
  yAxis = false
}) => {
  let values = import_fp.default.map(valueField, data);
  let max = import_fp.default.max(values);
  let min = import_fp.default.min(values);
  return /* @__PURE__ */ import_react.default.createElement(import_Flex.default, { style: { alignItems: "flex-end", justifyContent: "center" } }, yAxis && !!data.length && /* @__PURE__ */ import_react.default.createElement(YAxis, { ...{ min, max, height, borderColor: background } }), import_fp.default.map(
    (x) => /* @__PURE__ */ import_react.default.createElement("div", { key: x.key }, /* @__PURE__ */ import_react.default.createElement(
      "div",
      {
        style: {
          height: x[valueField] / max * height,
          background: background(x, max),
          margin: `0 ${gutter}px`
        },
        title: x[valueField]
      },
      "\xA0"
    ), /* @__PURE__ */ import_react.default.createElement("div", { style: { padding: "5px" } }, format(x[categoryField]))),
    data
  ));
};
var BarChart_default = (0, import_mobx_react.observer)(BarChart);
