var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var ExpandableTable_exports = {};
__export(ExpandableTable_exports, {
  Column: () => Column,
  default: () => ExpandableTable_default
});
module.exports = __toCommonJS(ExpandableTable_exports);
var import_fp = __toESM(require("lodash/fp.js"));
var import_futil = __toESM(require("futil"));
var import_react = __toESM(require("react"));
var import_mobx = require("../utils/mobx.js");
var import_mobx_react = require("mobx-react");
var import_DropdownItem = require("./DropdownItem.js");
var import_Popover = __toESM(require("./Popover.js"));
var import_Table = __toESM(require("./Table.js"));
var import_format = require("../utils/format.js");
var import_theme = require("../utils/theme.js");
let Column = import_fp.default.identity;
Column.displayName = "Column";
let ExpandedSection = (0, import_mobx_react.observer)(
  ({ columnCount, expandedRow }) => import_fp.default.getOr(null, "details.Component", expandedRow) && /* @__PURE__ */ import_react.default.createElement("tr", { align: "center" }, /* @__PURE__ */ import_react.default.createElement("td", { colSpan: columnCount }, expandedRow.details.Component(
    import_fp.default.get(expandedRow.field, expandedRow.record),
    expandedRow.record
  )))
);
let TableBodyState = () => {
  let state = {
    expanded: (0, import_mobx.observable)(/* @__PURE__ */ new Map()),
    onClick(field, keyField, record, index, details) {
      let key = record[keyField];
      let indexedField = `${field}${index}`;
      if (import_fp.default.get("indexedField", state.expanded.get(key)) !== indexedField && !record.isBlank) {
        state.expanded.set(key, {
          key,
          record,
          field,
          indexedField,
          details
        });
      } else {
        state.expanded.delete(key);
      }
    }
  };
  return state;
};
let TableBody = (0, import_mobx_react.inject)(TableBodyState)(
  (0, import_mobx_react.observer)(
    ({ data, columns, recordKey, expanded, onClick, blankRows, pageSize }) => {
      let rows = blankRows ? (0, import_format.addBlankRows)(data, pageSize, recordKey) : data;
      return /* @__PURE__ */ import_react.default.createElement("tbody", null, import_fp.default.map(
        (x) => /* @__PURE__ */ import_react.default.createElement(import_react.default.Fragment, { key: x[recordKey] }, /* @__PURE__ */ import_react.default.createElement(
          "tr",
          {
            ...x.rowAttrs,
            className: import_fp.default.getOr("", "rowAttrs.className", x) + (expanded.has(x[recordKey]) ? "expanded" : "")
          },
          import_futil.default.mapIndexed(
            ({ field, display = (x2) => x2, details = {} }, i) => /* @__PURE__ */ import_react.default.createElement(
              "td",
              {
                key: `${field}${i}`,
                ...!import_fp.default.isEmpty(details) && {
                  style: {
                    cursor: !import_fp.default.isEmpty(details) ? "pointer" : "auto"
                  },
                  onClick: () => onClick(field, recordKey, x, i, details, expanded)
                }
              },
              import_futil.default.when(
                () => x.isBlank,
                import_format.blankResult,
                import_fp.default.getOr(
                  display,
                  `${import_fp.default.isEqual(
                    import_fp.default.get(
                      "indexedField",
                      expanded.get(x[recordKey])
                    ),
                    `${field}${i}`
                  ) ? "collapse" : "expand"}.display`,
                  details
                )
              )(import_fp.default.get(field, x), x)
            ),
            columns
          )
        ), expanded.has(x[recordKey]) && /* @__PURE__ */ import_react.default.createElement(
          ExpandedSection,
          {
            expandedRow: expanded.get(x[recordKey]),
            columnCount: columns.length
          }
        )),
        rows
      ));
    }
  )
);
let TableState = (stores, props) => ({
  columns: import_fp.default.map(
    ({ props: props2 }) => ({
      ...import_fp.default.pick(["field", "label", "display", "enableSort"], props2),
      details: import_futil.default.compactObject({
        ...import_fp.default.pick(["expand", "collapse"], props2),
        Component: props2.children
      })
    }),
    import_fp.default.castArray(props.children)
  )
});
let ExpandableTable = (0, import_mobx_react.inject)(TableState)(
  (0, import_mobx_react.observer)(
    ({
      data,
      columns,
      recordKey = "key",
      columnSort = import_fp.default.identity,
      theme: { Icon },
      ...props
    }) => /* @__PURE__ */ import_react.default.createElement(import_Table.default, { ...props.tableAttrs }, /* @__PURE__ */ import_react.default.createElement("thead", null, /* @__PURE__ */ import_react.default.createElement("tr", null, import_futil.default.mapIndexed(
      (c, i) => /* @__PURE__ */ import_react.default.createElement(
        "th",
        {
          key: `${c.field}${i}`,
          ...c.enableSort && {
            style: { cursor: "pointer" }
          }
        },
        /* @__PURE__ */ import_react.default.createElement("span", null, import_futil.default.callOrReturn(import_fp.default.getOr(import_futil.default.autoLabel(c.field), "label", c)), c.enableSort && /* @__PURE__ */ import_react.default.createElement(
          import_Popover.default,
          {
            trigger: /* @__PURE__ */ import_react.default.createElement(Icon, { icon: "TableColumnMenu" }),
            position: `bottom ${i === columns.length - 1 ? "right" : "center"}`,
            style: {
              userSelect: "none",
              width: "auto"
            }
          },
          /* @__PURE__ */ import_react.default.createElement(
            import_DropdownItem.DropdownItem,
            {
              onClick: () => columnSort({ ...c, sortDir: "asc" })
            },
            /* @__PURE__ */ import_react.default.createElement(Icon, { icon: "SortAscending" }),
            "Sort Ascending"
          ),
          /* @__PURE__ */ import_react.default.createElement(
            import_DropdownItem.DropdownItem,
            {
              onClick: () => columnSort({ ...c, sortDir: "desc" })
            },
            /* @__PURE__ */ import_react.default.createElement(Icon, { icon: "SortDescending" }),
            "Sort Descending"
          )
        ))
      ),
      columns
    ))), /* @__PURE__ */ import_react.default.createElement(
      TableBody,
      {
        columns,
        data,
        recordKey,
        ...props
      }
    ))
  )
);
ExpandableTable.displayName = "ExpandableTable";
var ExpandableTable_default = (0, import_theme.withTheme)(ExpandableTable);
