var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var NestedPicker_exports = {};
__export(NestedPicker_exports, {
  default: () => NestedPicker_default
});
module.exports = __toCommonJS(NestedPicker_exports);
var import_react = __toESM(require("react"));
var import_futil = __toESM(require("futil"));
var import_fp = __toESM(require("lodash/fp.js"));
var import_react_recompose = require("react-recompose");
var import_mobx_react = require("mobx-react");
var import_mobx = require("../utils/mobx.js");
var import_theme = require("../utils/theme.js");
var import_pluralize = __toESM(require("pluralize"));
var import_Flex = __toESM(require("./Flex.js"));
var import_TextInput = __toESM(require("./TextInput.js"));
var import_TextHighlight = __toESM(require("./TextHighlight.js"));
var import_fields = require("../utils/fields.js");
let PickerContext = import_react.default.createContext();
let unflattenObjectBy = import_fp.default.curry(
  (iteratee, x) => import_fp.default.zipObjectDeep(import_futil.default.mapIndexed(iteratee, x), import_fp.default.values(x))
);
let getNonFieldItemLabel = import_futil.default.unless(import_fp.default.includes(" "), import_fp.default.startCase);
let getItemLabel = (item) => (0, import_fields.isField)(item) ? import_futil.default.cascade(["shortLabel", "label"], item) : getNonFieldItemLabel(item._key);
let toNested = import_fp.default.flow(
  import_fp.default.map((x) => import_fp.default.defaults({ path: x.value }, x)),
  (fields) => [
    ...import_fp.default.map(
      (field) => ({
        ...field,
        // flatten path of fields for this group after "CommonlyUsedFields"
        path: `CommonlyUsedFields.${import_fp.default.camelCase(field.path)}`
      }),
      import_fp.default.filter("isCommonlyUsed", fields)
    ),
    ...fields
  ],
  unflattenObjectBy("path")
);
let FilteredSection = import_fp.default.flow(
  (0, import_react_recompose.setDisplayName)("FilteredSection"),
  import_mobx_react.observer
)(
  ({
    options,
    highlight,
    style = { maxHeight: 340, overflowY: "scroll" },
    checked
  }) => {
    let { PickerItem, TextHighlight, setHoverItem } = import_react.default.useContext(PickerContext);
    return /* @__PURE__ */ import_react.default.createElement("div", { style }, import_futil.default.mapIndexed(
      (option, field) => /* @__PURE__ */ import_react.default.createElement(
        PickerItem,
        {
          key: field,
          isChecked: checked.has(option.value),
          onClick: () => {
            checked.has(option.value) ? checked.delete(option.value) : checked.set(option.value, option);
          },
          ...import_futil.default.domLens.hover(
            (isHover) => setHoverItem(isHover ? option : null)
          )
        },
        /* @__PURE__ */ import_react.default.createElement(TextHighlight, { text: option.label, pattern: highlight })
      ),
      options
    ));
  }
);
let Section = import_fp.default.flow(
  (0, import_react_recompose.setDisplayName)("Section"),
  import_mobx_react.observer
)(
  ({
    options,
    onClick,
    selected,
    checked,
    style = { overflow: "auto", width: "100%", maxHeight: 300 }
  }) => {
    let { PickerItem, setHoverItem } = import_react.default.useContext(PickerContext);
    return /* @__PURE__ */ import_react.default.createElement("div", { style }, import_fp.default.map(
      (item) => /* @__PURE__ */ import_react.default.createElement(
        PickerItem,
        {
          key: item._key,
          onClick: () => onClick(
            import_fp.default.isString(item.value) && item.value || item._key,
            item
          ),
          active: selected === item._key,
          hasChildren: !(0, import_fields.isField)(item),
          isChecked: checked.has(item.value),
          ...import_futil.default.domLens.hover(
            (isHover) => setHoverItem(isHover ? item : null)
          )
        },
        getItemLabel(item)
      ),
      import_fp.default.flow(import_futil.default.unkeyBy("_key"), import_fp.default.sortBy(getItemLabel))(options)
    ));
  }
);
let PanelTreePicker = (0, import_mobx_react.inject)((store, { options, checked }) => {
  let x = {
    checked,
    state: (0, import_mobx.observable)({ selected: [] }),
    nestedOptions: toNested(options),
    selectAtLevel: import_fp.default.curry((level, key, field) => {
      if ((0, import_fields.isField)(field)) {
        checked.has(field.value) ? checked.delete(field.value) : checked.set(field.value, field);
      } else {
        x.state.selected.splice(level, x.state.selected.length - level, key);
      }
    })
  };
  return x;
})(
  (0, import_mobx_react.observer)(({ selectAtLevel, state, nestedOptions, checked }) => /* @__PURE__ */ import_react.default.createElement(
    "div",
    {
      className: "panel-tree-picker",
      style: { display: "inline-flex", width: "100%" }
    },
    /* @__PURE__ */ import_react.default.createElement(
      Section,
      {
        checked,
        options: nestedOptions,
        onClick: selectAtLevel(0),
        selected: state.selected[0]
      }
    ),
    import_futil.default.mapIndexed(
      (_key, index) => /* @__PURE__ */ import_react.default.createElement(
        Section,
        {
          key: index,
          checked,
          options: import_fp.default.get(state.selected.slice(0, index + 1), nestedOptions),
          onClick: selectAtLevel(index + 1),
          selected: state.selected[index + 1]
        }
      ),
      state.selected
    )
  ))
);
PanelTreePicker.displayName = "PanelTreePicker";
let matchLabel = (str) => import_fp.default.filter((x) => import_futil.default.matchAllWords(str)(x.label));
let NestedPicker = ({
  options,
  onChange,
  PickerItem = "div",
  TextInput = import_TextInput.default,
  TextHighlight = import_TextHighlight.default,
  itemType = "filter",
  style = {},
  theme: { Button }
}) => {
  let [state] = import_react.default.useState(
    () => (0, import_mobx.observable)({
      filter: "",
      checked: /* @__PURE__ */ new Map(),
      hoverItem: null,
      get hasItemDescription() {
        return import_fp.default.flow(import_fp.default.trim, import_futil.default.isNotBlank)(state.hoverItem?.description);
      }
    })
  );
  let showDescriptionPanel = import_fp.default.some("description", options);
  return /* @__PURE__ */ import_react.default.createElement(
    PickerContext.Provider,
    {
      value: {
        PickerItem,
        TextHighlight,
        setHoverItem: import_fp.default.debounce(100, (item) => state.hoverItem = item)
      }
    },
    /* @__PURE__ */ import_react.default.createElement(import_Flex.default, { style }, showDescriptionPanel && /* @__PURE__ */ import_react.default.createElement(import_mobx_react.Observer, null, () => /* @__PURE__ */ import_react.default.createElement(
      import_Flex.default,
      {
        alignItems: "center",
        className: "gv-picker-description-container",
        style: {
          flexShrink: 0,
          flexBasis: 200,
          paddingLeft: 16,
          paddingRight: 16,
          textAlign: state.hasItemDescription ? "left" : "center"
        }
      },
      state.hasItemDescription ? /* @__PURE__ */ import_react.default.createElement("div", null, /* @__PURE__ */ import_react.default.createElement("em", null, /* @__PURE__ */ import_react.default.createElement("h4", null, state.hoverItem.label)), /* @__PURE__ */ import_react.default.createElement("em", null, state.hoverItem.description)) : /* @__PURE__ */ import_react.default.createElement("em", null, "Hover over a field to view the description")
    )), /* @__PURE__ */ import_react.default.createElement("div", { style: { padding: 16, flexGrow: 1 } }, /* @__PURE__ */ import_react.default.createElement(import_mobx_react.Observer, null, () => /* @__PURE__ */ import_react.default.createElement(import_react.default.Fragment, null, /* @__PURE__ */ import_react.default.createElement(
      TextInput,
      {
        style: { marginBottom: 10 },
        value: state.filter,
        onChange: (e) => state.filter = e.target.value,
        placeholder: "Enter filter keyword..."
      }
    ), state.filter ? /* @__PURE__ */ import_react.default.createElement(
      FilteredSection,
      {
        checked: state.checked,
        highlight: state.filter,
        options: matchLabel(state.filter)(options)
      }
    ) : /* @__PURE__ */ import_react.default.createElement(PanelTreePicker, { options, checked: state.checked }))), /* @__PURE__ */ import_react.default.createElement(import_Flex.default, { justifyContent: "space-between", style: { marginTop: 20 } }, /* @__PURE__ */ import_react.default.createElement(
      Button,
      {
        onClick: () => {
          state.checked = /* @__PURE__ */ new Map();
          onChange();
        }
      },
      "Cancel"
    ), /* @__PURE__ */ import_react.default.createElement(import_mobx_react.Observer, null, () => !!state.checked.size && /* @__PURE__ */ import_react.default.createElement(
      Button,
      {
        primary: true,
        onClick: () => onChange(Array.from(state.checked.values()))
      },
      "Add",
      " ",
      `${state.checked.size} ${(0, import_pluralize.default)(
        itemType,
        state.checked.size
      )}`
    )))))
  );
};
var NestedPicker_default = (0, import_theme.withTheme)(NestedPicker);
