var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var TableFooter_exports = {};
__export(TableFooter_exports, {
  default: () => TableFooter_default
});
module.exports = __toCommonJS(TableFooter_exports);
var import_react = __toESM(require("react"));
var import_fp = __toESM(require("lodash/fp.js"));
var import_futil = __toESM(require("futil"));
var import_Pager = __toESM(require("./Pager.js"));
var import_PagerItem = __toESM(require("./PagerItem.js"));
var import_PageSize = __toESM(require("./PageSize.js"));
var import_Flex = __toESM(require("./Flex.js"));
var import_format = require("../utils/format.js");
let PageDetails = ({ startRecord, endRecord, totalRecords, hasMore }) => /* @__PURE__ */ import_react.default.createElement("span", { style: { flex: "0 1 30%", textAlign: "right" } }, /* @__PURE__ */ import_react.default.createElement("b", null, "Showing "), startRecord >= endRecord ? endRecord : `${(0, import_format.toNumber)(startRecord)}-${(0, import_format.toNumber)(endRecord)}`, import_futil.default.isNotNil(totalRecords) && ` of ${(0, import_format.toNumber)(totalRecords)}${hasMore ? "+" : ""}`);
let TableFooter = ({
  page = 1,
  onChangePage,
  pageSize,
  onChangePageSize,
  pageSizeOptions,
  hasMore,
  totalRecords,
  startRecord = pageSize * (page - 1) + 1,
  endRecord = hasMore ? page * pageSize : 0,
  disabled = false,
  ...props
}) => {
  if (totalRecords)
    endRecord = endRecord || import_fp.default.min([page * pageSize, totalRecords]);
  if (!hasMore && !totalRecords)
    totalRecords = endRecord;
  let pageCount = import_fp.default.ceil((totalRecords || endRecord) / pageSize);
  return /* @__PURE__ */ import_react.default.createElement(
    import_Flex.default,
    {
      className: "gv-table-footer",
      justifyContent: "space-between",
      alignItems: "center",
      ...props
    },
    /* @__PURE__ */ import_react.default.createElement(
      import_PageSize.default,
      {
        sizeOptions: pageSizeOptions,
        value: pageSize,
        onChange: onChangePageSize,
        style: { flex: "0 1 30%" }
      }
    ),
    /* @__PURE__ */ import_react.default.createElement(import_Flex.default, { style: { flex: 1 }, alignItems: "center", justifyContent: "center" }, /* @__PURE__ */ import_react.default.createElement(
      import_Pager.default,
      {
        disabled,
        value: page,
        onChange: onChangePage,
        pageCount
      }
    ), hasMore && page >= pageCount && /* @__PURE__ */ import_react.default.createElement(
      import_PagerItem.default,
      {
        disabled,
        style: { margin: "0 8px", paddingLeft: 12, paddingRight: 12 },
        onClick: () => onChangePage(page + 1)
      },
      "Load More..."
    )),
    totalRecords > 0 && /* @__PURE__ */ import_react.default.createElement(PageDetails, { ...{ totalRecords, startRecord, endRecord, hasMore } })
  );
};
var TableFooter_default = TableFooter;
