var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var TagsInput_exports = {};
__export(TagsInput_exports, {
  default: () => TagsInput_default
});
module.exports = __toCommonJS(TagsInput_exports);
var import_react = __toESM(require("react"));
var import_fp = __toESM(require("lodash/fp.js"));
var import_mobx_react = require("mobx-react");
var import_Flex = __toESM(require("./Flex.js"));
var import_Tag = __toESM(require("./Tag.js"));
var import_utils = require("./utils.js");
let isValidInput = (tag, tags) => !import_fp.default.isEmpty(tag) && !import_fp.default.includes(tag, tags);
let TagsInput = (0, import_react.forwardRef)(
  ({
    tags,
    addTags: setTags,
    removeTag,
    submit = import_fp.default.noop,
    tagStyle,
    placeholder = "Search...",
    splitCommas,
    style,
    onBlur = import_fp.default.noop,
    onInputChange = import_fp.default.noop,
    onTagClick = import_fp.default.noop,
    sanitizeTagFn,
    Tag = import_Tag.default,
    ...props
  }, inputRef) => {
    let containerRef = import_react.default.useRef();
    let [currentInput, setCurrentInput] = import_react.default.useState("");
    let addTags = (input) => {
      let newTags = (0, import_utils.createTags)({ input, splitCommas, sanitizeTagFn });
      setTags(import_fp.default.difference(newTags, tags));
    };
    return /* @__PURE__ */ import_react.default.createElement("div", { className: "tags-input", ref: containerRef, style: { ...style } }, /* @__PURE__ */ import_react.default.createElement(
      import_Flex.default,
      {
        wrap: true,
        alignItems: "center",
        style: {
          cursor: "text",
          height: "100%",
          padding: 2
        }
      },
      import_fp.default.map(
        (t) => /* @__PURE__ */ import_react.default.createElement(
          Tag,
          {
            key: t,
            value: t,
            ...{ removeTag, tagStyle },
            onClick: () => onTagClick(t)
          }
        ),
        tags
      ),
      /* @__PURE__ */ import_react.default.createElement(
        "input",
        {
          style: {
            border: "none",
            outline: "none",
            flex: 1,
            margin: 3,
            minWidth: 120
          },
          ref: inputRef,
          onChange: (e) => {
            setCurrentInput(e.target.value);
            onInputChange();
          },
          onBlur: () => {
            if (isValidInput(currentInput, tags)) {
              addTags(currentInput);
              setCurrentInput("");
              onBlur();
            }
          },
          onKeyDown: (e) => {
            if (e.key === "Enter" && !currentInput)
              submit();
            if ((import_fp.default.includes(e.key, ["Enter", "Tab"]) || splitCommas && e.key === ",") && isValidInput(currentInput, tags)) {
              addTags(currentInput);
              setCurrentInput("");
              e.preventDefault();
            }
            if (e.key === "Backspace" && !currentInput && tags.length) {
              let last = import_fp.default.last(tags);
              removeTag(last);
              setCurrentInput(last);
              e.preventDefault();
            }
          },
          value: currentInput,
          placeholder,
          ...import_fp.default.omit(["onTagsDropped", "maxTags", "Loader"], props)
        }
      )
    ));
  }
);
var TagsInput_default = (0, import_mobx_react.observer)(TagsInput);
