var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var utils_exports = {};
__export(utils_exports, {
  createTags: () => createTags,
  openBinding: () => openBinding,
  sanitizeQueryStringTag: () => sanitizeQueryStringTag
});
module.exports = __toCommonJS(utils_exports);
var import_fp = __toESM(require("lodash/fp.js"));
var import_futil = __toESM(require("futil"));
var import_tagsQuery = require("contexture-util/exampleTypes/tagsQuery.js");
var import_escape_string_regexp = __toESM(require("escape-string-regexp"));
let openBinding = (...lens) => ({
  isOpen: import_futil.default.view(...lens),
  onClose: import_futil.default.off(...lens)
});
let maxWordsPerTag = 100;
let maxCharsPerTagWord = 100;
let wordRegexp = new RegExp(
  `[^${(0, import_escape_string_regexp.default)(import_tagsQuery.queryStringCharacterBlacklist)}]+`,
  "g"
);
let words = import_fp.default.words.convert({ fixed: false });
let sanitizeQueryStringTag = import_fp.default.flow(
  (string) => words(string, wordRegexp),
  import_fp.default.take(maxWordsPerTag),
  import_fp.default.map(
    (word) => import_fp.default.flow(
      import_fp.default.truncate({ length: maxCharsPerTagWord, omission: "" }),
      // Remove beginning of line dash and space dash
      // https://github.com/smartprocure/spark/issues/10923
      import_fp.default.replace(/^-| -/g, " "),
      import_fp.default.trim
    )(word)
  ),
  import_fp.default.join(" ")
);
let splitTagOnComma = import_fp.default.flow(
  import_fp.default.split(","),
  import_fp.default.invokeMap("trim"),
  import_fp.default.compact,
  import_fp.default.uniq
);
let createTags = ({ input, splitCommas, sanitizeTagFn }) => import_fp.default.flow(
  import_fp.default.trim,
  splitCommas ? splitTagOnComma : import_fp.default.identity,
  import_fp.default.castArray,
  sanitizeTagFn ? import_fp.default.map(sanitizeTagFn) : import_fp.default.identity,
  import_fp.default.map(import_fp.default.trim),
  import_fp.default.compact
)(input);
