var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var StepsAccordion_exports = {};
__export(StepsAccordion_exports, {
  AccordionStep: () => AccordionStep,
  default: () => StepsAccordion_default
});
module.exports = __toCommonJS(StepsAccordion_exports);
var import_fp = __toESM(require("lodash/fp.js"));
var import_futil = __toESM(require("futil"));
var import_mobx_react = require("mobx-react");
var import_react = __toESM(require("react"));
var import_react_recompose = require("react-recompose");
var import_greyVest = require("../greyVest/index.js");
var import_theme = require("../utils/theme.js");
let Buttons = import_fp.default.flow(
  (0, import_react_recompose.setDisplayName)("Buttons"),
  import_mobx_react.observer,
  import_theme.withTheme
)(({ step, totalSteps, currentStep, onSubmit, theme: { Button, Icon } }) => /* @__PURE__ */ import_react.default.createElement(import_react.default.Fragment, null, step > 0 && /* @__PURE__ */ import_react.default.createElement(Button, { onClick: import_futil.default.sets(step - 1, currentStep), className: "back-button" }, /* @__PURE__ */ import_react.default.createElement(Icon, { icon: "PreviousPage" }), "Back"), step < totalSteps - 1 ? /* @__PURE__ */ import_react.default.createElement(Button, { primary: true, onClick: import_futil.default.sets(step + 1, currentStep), disabled: false }, "Continue") : /* @__PURE__ */ import_react.default.createElement(Button, { primary: true, onClick: onSubmit }, "View Results")));
let AccordionStep = import_fp.default.flow(
  (0, import_react_recompose.setDisplayName)("AccordionStep"),
  import_theme.withTheme
)(
  ({
    style,
    className,
    step,
    totalSteps,
    currentStep,
    title,
    isRequired = false,
    onSubmit,
    children,
    theme: { Icon }
  }) => {
    let open = import_futil.default.view(currentStep) === step;
    return /* @__PURE__ */ import_react.default.createElement("div", { className: `accordion-step ${className || ""}`, style }, /* @__PURE__ */ import_react.default.createElement(
      import_greyVest.Flex,
      {
        alignItems: "center",
        justifyContent: "space-between",
        onClick: import_futil.default.sets(open ? -1 : step, currentStep),
        style: { cursor: "pointer" }
      },
      /* @__PURE__ */ import_react.default.createElement(import_greyVest.Flex, { alignItems: "center" }, /* @__PURE__ */ import_react.default.createElement("div", { className: "accordion-step-title" }, import_futil.default.callOrReturn(title, step)), !isRequired && /* @__PURE__ */ import_react.default.createElement("em", { style: { marginLeft: 6 } }, "(Optional)")),
      /* @__PURE__ */ import_react.default.createElement("div", { className: "filter-field-label-icon" }, /* @__PURE__ */ import_react.default.createElement(Icon, { icon: open ? "FilterListCollapse" : "FilterListExpand" }))
    ), open && /* @__PURE__ */ import_react.default.createElement(import_react.default.Fragment, null, /* @__PURE__ */ import_react.default.createElement("div", { className: "step-contents" }, children), /* @__PURE__ */ import_react.default.createElement(Buttons, { ...{ step, totalSteps, currentStep, onSubmit } })));
  }
);
let StepsAccordion = ({ onSubmit = import_fp.default.noop, children, className, ...props }) => {
  let currentStep = import_react.default.useState(0);
  return /* @__PURE__ */ import_react.default.createElement("div", { className: `steps-accordion ${className || ""}`, ...props }, import_react.default.Children.map(children, (child, i) => /* @__PURE__ */ import_react.default.createElement(
    child.type,
    {
      ...{ currentStep, onSubmit },
      key: i,
      step: i,
      totalSteps: import_fp.default.size(children),
      ...child.props
    }
  )));
};
var StepsAccordion_default = StepsAccordion;
