var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var FilterContents_exports = {};
__export(FilterContents_exports, {
  default: () => FilterContents_default
});
module.exports = __toCommonJS(FilterContents_exports);
var import_futil = __toESM(require("futil"));
var import_fp = __toESM(require("lodash/fp.js"));
var import_react = __toESM(require("react"));
var import_mobx_react = require("mobx-react");
var import_greyVest = require("../greyVest/index.js");
var import_purgatory = require("../purgatory/index.js");
var import_fields = require("../utils/fields.js");
var import_mobx_utils = require("../utils/mobx-utils.js");
var import_search = require("../utils/search.js");
var import_theme = require("../utils/theme.js");
let FilterContents = ({
  node,
  tree,
  fields,
  mapNodeToProps = import_fp.default.noop,
  style,
  theme: { Select, UnmappedNodeComponent }
}) => {
  let nodeField = (0, import_mobx_utils.get)(node, "field");
  let typeOptions = import_fp.default.get([nodeField, "typeOptions"], fields) || [];
  if (node.type && !import_fp.default.includes(node.type, typeOptions))
    typeOptions = [...typeOptions, node.type];
  let nodeLabel = import_fp.default.get([nodeField, "label"], fields) || nodeField;
  return /* @__PURE__ */ import_react.default.createElement(import_greyVest.Grid, { columns: "auto auto minmax(0, 1fr)", style }, /* @__PURE__ */ import_react.default.createElement(
    import_purgatory.ModalPicker,
    {
      label: nodeField ? nodeLabel : "Pick a Field",
      options: (0, import_fields.fieldsToOptions)(fields),
      onChange: (addedFields) => {
        addedFields = import_fp.default.castArray(addedFields);
        if (addedFields[0])
          tree.replace(
            node.path,
            (0, import_search.transformNodeFromField)({ field: addedFields[0].field, fields })
          );
        import_fp.default.each(
          ({ field }) => tree.add(
            node.path.slice(0, -1),
            (0, import_search.newNodeFromField)({ field, fields })
          ),
          addedFields.slice(1)
        );
      }
    }
  ), nodeField && /* @__PURE__ */ import_react.default.createElement("div", { style: { margin: "0 5px" } }, /* @__PURE__ */ import_react.default.createElement(
    Select,
    {
      onChange: ({ target: { value: type } }) => {
        tree.replace(node.path, (0, import_search.newNodeFromType)(type, fields, node));
      },
      placeholder: "Select Type",
      value: import_futil.default.when(import_fp.default.isNil, void 0)(node.type),
      options: (0, import_search.getTypeLabelOptions)(tree, typeOptions)
    }
  )), node.type && /* @__PURE__ */ import_react.default.createElement(
    "div",
    {
      style: {
        display: "inline-block",
        verticalAlign: "top",
        width: "100%",
        marginRight: "5px"
      }
    },
    /* @__PURE__ */ import_react.default.createElement(
      import_greyVest.Dynamic,
      {
        ...{
          component: UnmappedNodeComponent,
          tree,
          node,
          ...mapNodeToProps(node, fields)
        }
      }
    )
  ));
};
var FilterContents_default = import_fp.default.flow(import_mobx_react.observer, import_theme.withTheme)(FilterContents);
