var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var Operator_exports = {};
__export(Operator_exports, {
  default: () => Operator_default
});
module.exports = __toCommonJS(Operator_exports);
var import_react = __toESM(require("react"));
var import_fp = __toESM(require("lodash/fp.js"));
var import_futil = __toESM(require("futil"));
var import_mobx_react = require("mobx-react");
var import_styles = __toESM(require("../styles/index.js"));
var import_OperatorMenu = __toESM(require("./OperatorMenu.js"));
var import_FilterDropTarget = require("./DragDrop/FilterDropTarget.js");
let HorizontalLine = (0, import_mobx_react.observer)(({ node, child }) => {
  const marginLeft = `${(import_styles.default.operatorWidth - import_styles.default.lineWidth) / 2}px`;
  return /* @__PURE__ */ import_react.default.createElement(
    "div",
    {
      style: {
        width: child.children ? "100%" : `calc(100% - ${marginLeft})`,
        height: import_styles.default.operatorHeight / 2,
        marginLeft,
        borderBottom: `solid ${import_styles.default.lineWidth}px black`,
        borderBottomColor: import_styles.default.joinColor(node.join)
      }
    }
  );
});
let VerticalLine = (0, import_mobx_react.observer)(({ node }) => /* @__PURE__ */ import_react.default.createElement(
  "div",
  {
    style: {
      flex: 1,
      marginLeft: `${(import_styles.default.operatorWidth - import_styles.default.lineWidth) / 2}px`,
      borderLeft: `solid ${import_styles.default.lineWidth}px black`,
      borderLeftColor: import_styles.default.joinColor(node.join)
    }
  }
));
let OperatorTag = (0, import_mobx_react.observer)(({ node, hover, theme }) => /* @__PURE__ */ import_react.default.createElement(
  theme.Button,
  {
    style: {
      width: `${import_styles.default.operatorWidth}px`,
      lineHeight: `${import_styles.default.operatorHeight}px`,
      ...import_styles.default.bgJoin(import_futil.default.view(hover.join) || node),
      ...import_futil.default.view(hover.join) && { fontStyle: "italic" },
      // Reset button styles
      padding: 0,
      ...import_styles.default.buttonStyleReset
    }
  },
  import_futil.default.view(hover.join) || node.join
));
let Operator = ({ hover, node, child, parent, tree, index, theme, adding }) => {
  const isLast = index === import_fp.default.size(import_fp.default.toArray(node.children)) - 1;
  const [{ canDrop }, drop] = (0, import_FilterDropTarget.useFilterDropTarget)({
    drop(source) {
      tree.move(source.node.path, {
        path: node.path,
        index: index + 1
      });
    }
  });
  return /* @__PURE__ */ import_react.default.createElement(
    "div",
    {
      ref: drop,
      style: {
        position: "relative",
        display: "flex",
        flexDirection: "column",
        width: `${import_styles.default.operatorWidth + import_styles.default.ruleGutter}px`,
        ...canDrop && import_styles.default.bgPreview(node)
      }
    },
    (index !== 0 || node.join === "not") && /* @__PURE__ */ import_react.default.createElement("div", { style: { position: "absolute" } }, /* @__PURE__ */ import_react.default.createElement(
      theme.Popover,
      {
        trigger: /* @__PURE__ */ import_react.default.createElement(OperatorTag, { ...{ node, hover, theme, canDrop } }),
        style: {
          // Add top spacing between popover and trigger
          marginTop: "10px",
          padding: import_styles.default.boxPadding
        }
      },
      /* @__PURE__ */ import_react.default.createElement(import_OperatorMenu.default, { ...{ node, hover, tree, parent, child, theme } })
    )),
    /* @__PURE__ */ import_react.default.createElement(HorizontalLine, { ...{ node, child } }),
    (!isLast || import_futil.default.view(adding)) && /* @__PURE__ */ import_react.default.createElement(VerticalLine, { node })
  );
};
var Operator_default = (0, import_mobx_react.observer)(Operator);
