var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var Rule_exports = {};
__export(Rule_exports, {
  default: () => Rule_default
});
module.exports = __toCommonJS(Rule_exports);
var import_react = __toESM(require("react"));
var import_mobx_react = require("mobx-react");
var import_futil = __toESM(require("futil"));
var import_styles = __toESM(require("../styles/index.js"));
var import_Indentable = __toESM(require("./preview/Indentable.js"));
var import_FilterContents = __toESM(require("./FilterContents.js"));
var import_IndentTarget = require("./DragDrop/IndentTarget.js");
var import_FilterDragSource = __toESM(require("./DragDrop/FilterDragSource.js"));
var import_FilterDropTarget = require("./DragDrop/FilterDropTarget.js");
var import_search = require("../utils/search.js");
var import_react2 = require("../utils/react.js");
let Rule = ({ index, node, parent, tree, style, theme, ...props }) => {
  const [{ isDragging }, drag] = (0, import_FilterDragSource.default)({ node, tree, ...props });
  let hover = (0, import_react2.useLensObject)({
    indent: false,
    remove: false,
    rule: false
  });
  let [{ canDrop, isOver }, drop] = (0, import_FilterDropTarget.useFilterDropTarget)({
    drop(source) {
      tree.move(source.node.path, {
        path: parent.path,
        index: index + 1
      });
    }
  });
  return /* @__PURE__ */ import_react.default.createElement(
    import_Indentable.default,
    {
      parent,
      indent: hover.indent,
      theme,
      isLeaf: true,
      style: {
        ...style,
        marginBottom: !canDrop && import_styles.default.ruleGutter
      }
    },
    /* @__PURE__ */ import_react.default.createElement(
      "div",
      {
        ref: drag,
        style: {
          ...import_styles.default.condition,
          ...import_styles.default.bdJoin(parent),
          ...import_futil.default.view(hover.remove) && {
            borderStyle: "dashed",
            opacity: 0.25,
            ...import_styles.default.bgStriped
          },
          ...isDragging && { opacity: 0.25 },
          ...import_futil.default.view(hover.rule) && { background: import_styles.default.background }
        },
        ...import_futil.default.domLens.hover(hover.rule)
      },
      /* @__PURE__ */ import_react.default.createElement("div", { style: { display: "flex", gap: "8px", position: "relative" } }, /* @__PURE__ */ import_react.default.createElement(import_FilterContents.default, { ...{ node, tree, ...props }, style: { flex: 1 } }), /* @__PURE__ */ import_react.default.createElement(
        theme.ButtonGroup,
        {
          style: {
            height: "fit-content",
            visibility: (!import_futil.default.view(hover.rule) || isDragging) && "hidden"
          }
        },
        /* @__PURE__ */ import_react.default.createElement(
          theme.Button,
          {
            ...import_futil.default.domLens.hover(hover.indent),
            style: {
              display: "flex",
              alignItems: "center",
              justifyContent: "center",
              padding: 0,
              width: `${import_styles.default.operatorWidth}px`,
              height: `${import_styles.default.operatorHeight}px`,
              background: import_styles.default.joinColor((0, import_search.oppositeJoin)(parent?.join))
            },
            onClick: () => (0, import_search.indent)(tree, parent, node)
          },
          ">"
        ),
        /* @__PURE__ */ import_react.default.createElement(
          theme.Button,
          {
            ...import_futil.default.domLens.hover(hover.remove),
            onClick: () => tree.remove(node.path),
            style: {
              display: "flex",
              alignItems: "center",
              justifyContent: "center",
              padding: 0,
              width: `${import_styles.default.operatorWidth}px`,
              height: `${import_styles.default.operatorHeight}px`
            }
          },
          "X"
        )
      ), /* @__PURE__ */ import_react.default.createElement(import_IndentTarget.FilterIndentTarget, { child: node, node: parent, tree }))
    ),
    canDrop && /* @__PURE__ */ import_react.default.createElement(
      "div",
      {
        ref: drop,
        style: {
          ...import_styles.default.bgPreview(parent),
          height: isOver ? import_styles.default.operatorWidth : import_styles.default.ruleGutter - import_styles.default.ruleGutter / 2,
          margin: import_styles.default.ruleGutter / 4,
          borderRadius: import_styles.default.borderRadius
        }
      }
    )
  );
};
var Rule_default = (0, import_mobx_react.observer)(Rule);
