var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var facet_exports = {};
__export(facet_exports, {
  Cardinality: () => Cardinality,
  FacetCheckboxList: () => FacetCheckboxList,
  FacetOptionsFilter: () => FacetOptionsFilter,
  SelectAll: () => SelectAll,
  displayBlankFn: () => displayBlankFn,
  displayFn: () => displayFn
});
module.exports = __toCommonJS(facet_exports);
var import_react = __toESM(require("react"));
var import_fp = __toESM(require("lodash/fp.js"));
var import_futil = __toESM(require("futil"));
var import_theme = require("../utils/theme.js");
var import_format = require("../utils/format.js");
var import_react_recompose = require("react-recompose");
var import_mobx_react = require("mobx-react");
var import_greyVest = require("../greyVest/index.js");
var import_hoc = require("../utils/hoc.js");
let commonStyle = {
  justifyContent: "space-between",
  alignItems: "center",
  display: "flex",
  cursor: "pointer"
};
let displayFn = (name, label) => import_fp.default.isString(label) ? label : name;
let displayBlankFn = () => /* @__PURE__ */ import_react.default.createElement("i", null, "Not Specified");
let Cardinality = import_fp.default.flow(
  (0, import_react_recompose.setDisplayName)("Cardinality"),
  import_mobx_react.observer
)(({ node, tree }) => {
  let size = node.size || 10;
  let count = import_fp.default.get("context.cardinality", node);
  if (count) {
    return /* @__PURE__ */ import_react.default.createElement(
      import_greyVest.Flex,
      {
        className: "contexture-facet-cardinality",
        justifyContent: "space-between"
      },
      /* @__PURE__ */ import_react.default.createElement("div", null, "Showing ", (0, import_format.toNumber)(import_fp.default.min([size, import_fp.default.size(node.context.options)])), " of", " ", (0, import_format.toNumber)(count)),
      count > size && /* @__PURE__ */ import_react.default.createElement("div", null, /* @__PURE__ */ import_react.default.createElement(
        "a",
        {
          onClick: () => tree.mutate(node.path, { size: size + 10 }),
          style: { cursor: "pointer" }
        },
        "View More"
      ))
    );
  }
  return null;
});
let SelectAll = import_fp.default.flow(
  (0, import_react_recompose.setDisplayName)("SelectAll"),
  import_mobx_react.observer,
  import_theme.withTheme
)(({ node, tree, theme: { Checkbox }, maxChecked = 500 }) => {
  let notChecked = import_fp.default.difference(
    import_fp.default.map("name", import_fp.default.get("context.options", node)),
    node.values
  );
  let isAllChecked = import_fp.default.isEmpty(notChecked);
  let allChecked = [...node.values, ...notChecked];
  let isOverTheLimit = import_fp.default.size(allChecked) > maxChecked;
  return !isOverTheLimit || isAllChecked ? /* @__PURE__ */ import_react.default.createElement("label", { style: commonStyle }, /* @__PURE__ */ import_react.default.createElement(
    Checkbox,
    {
      checked: isAllChecked,
      onChange: () => {
        if (isAllChecked)
          tree.mutate(node.path, {
            values: []
          });
        else {
          tree.mutate(node.path, { values: allChecked });
        }
      }
    }
  ), /* @__PURE__ */ import_react.default.createElement("div", { style: { flex: 2, padding: "0 5px" } }, "Select All Visible")) : null;
});
let FacetOptionsFilter = import_fp.default.flow(
  (0, import_react_recompose.setDisplayName)("FacetOptionsFilter"),
  import_mobx_react.observer,
  import_theme.withTheme
)(({ tree, node, theme: { TextInput, Button, ButtonGroup } }) => {
  let [val, setVal] = (0, import_react.useState)(node.optionsFilter);
  let buttonEnabled = val !== node.optionsFilter;
  let submit = () => buttonEnabled && tree.mutate(node.path, { optionsFilter: val });
  return /* @__PURE__ */ import_react.default.createElement(ButtonGroup, null, /* @__PURE__ */ import_react.default.createElement(
    TextInput,
    {
      value: val,
      onChange: (e) => {
        setVal(e.target.value);
      },
      onKeyPress: (e) => e.key === "Enter" && submit(),
      onBlur: submit,
      placeholder: "Search..."
    }
  ), /* @__PURE__ */ import_react.default.createElement(Button, { primary: node.optionsFilter !== val, onClick: submit }, "Find"));
});
let FacetCheckboxList = (0, import_hoc.contexturifyWithoutLoader)(
  ({
    tree,
    node,
    hide,
    display = displayFn,
    displayBlank = displayBlankFn,
    formatCount,
    theme: { Checkbox }
  }) => import_fp.default.flow(
    import_fp.default.partition((x) => import_fp.default.includes(x.name, node.values)),
    import_fp.default.flatten,
    import_futil.default.mapIndexed(({ name, label, count }, i) => {
      let lens = tree.lens(node.path, "values");
      const displayName = display(name, label);
      return /* @__PURE__ */ import_react.default.createElement(
        "label",
        {
          key: i,
          style: commonStyle,
          title: `${typeof displayName === "string" ? displayName : name} : ${formatCount(count)}`
        },
        /* @__PURE__ */ import_react.default.createElement(Checkbox, { ...import_futil.default.domLens.checkboxValues(name, lens) }),
        /* @__PURE__ */ import_react.default.createElement("div", { style: { flex: 2, padding: "0 5px" } }, displayName || displayBlank()),
        !hide.counts && /* @__PURE__ */ import_react.default.createElement("div", null, formatCount(count))
      );
    })
  )(import_fp.default.get("context.options", node))
);
