var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var format_exports = {};
__export(format_exports, {
  addBlankRows: () => addBlankRows,
  blankResult: () => blankResult,
  toNumber: () => toNumber
});
module.exports = __toCommonJS(format_exports);
var import_fp = __toESM(require("lodash/fp.js"));
var import_react = __toESM(require("react"));
let toNumber = (number, ...params) => {
  if (import_fp.default.isNumber(number)) {
    let formatter = Intl.NumberFormat(params);
    return formatter.format(number);
  }
  return NaN;
};
let addBlankRows = (rows, pageSize, key) => {
  if (rows.length === 0)
    return rows;
  let blankRows = [...Array(pageSize - rows.length)].map((_2, i) => ({
    ...rows[i % rows.length],
    // unique deterministic IDs
    [key]: `${rows[i % rows.length][key]}${i}`,
    isBlank: true
  }));
  return [...rows, ...blankRows];
};
let blank = import_fp.default.memoize(import_fp.default.replace(/[^ |]/gi, "\u2588"));
let toBlankText = (display, data, record, props) => {
  let rendered = display(data, record, props);
  if (typeof rendered === "object") {
    try {
      return display(blank(data), record, props);
    } catch {
      return blank(import_fp.default.toString(data).slice(40));
    }
  } else {
    return blank(rendered);
  }
};
let blankResult = (display) => (data, record, props) => /* @__PURE__ */ import_react.default.createElement(
  "span",
  {
    style: {
      fontFamily: "monospace",
      display: "inline-block",
      opacity: 0.2
    }
  },
  toBlankText(display, data, record, props)
);
