var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var geo_exports = {};
__export(geo_exports, {
  geoCodeLocation: () => geoCodeLocation,
  loadOptions: () => loadOptions,
  lookupByLocationId: () => lookupByLocationId
});
module.exports = __toCommonJS(geo_exports);
var import_fp = __toESM(require("lodash/fp.js"));
const defaultConfig = {
  apiKey: "YOUR_API_KEY_GOES_HERE",
  country: "USA",
  minCharacters: 3,
  lookup: "https://lookup.search.hereapi.com/v1/lookup",
  geoCoding: "https://geocode.search.hereapi.com/v1/geocode",
  autoComplete: "https://autocomplete.search.hereapi.com/v1/autocomplete"
};
let loadOptions = async (input, config = {}) => {
  let finalConfig = import_fp.default.defaults(defaultConfig, config);
  let { autoComplete: url, apiKey, country, minCharacters } = finalConfig;
  if (input.length < minCharacters)
    return [];
  let apiUrl = `${url}?apiKey=${apiKey}&in=countryCode:${country}&q=${encodeURIComponent(
    input
  )}`;
  let data = await (await fetch(apiUrl)).json();
  if (data.error) {
    console.error("geo > loadOptions error:", data.error);
    throw new Error(data.error);
  } else {
    return import_fp.default.getOr([], "items", data).map((suggestion) => ({
      label: import_fp.default.get("address.label", suggestion),
      value: import_fp.default.get("id", suggestion)
    }));
  }
};
let lookupByLocationId = async (locationId, config) => {
  let { lookup: url, apiKey } = config;
  let apiUrl = `${url}?apiKey=${apiKey}&id=${locationId}`;
  return (await fetch(apiUrl)).json();
};
let geoCodeLocation = async (string, config = {}) => {
  let { geoCoding: url, apiKey } = import_fp.default.defaults(defaultConfig, config);
  let apiUrl = `${url}?apiKey=${apiKey}&q=${encodeURIComponent(string)}`;
  return (await fetch(apiUrl)).json();
};
