var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var search_exports = {};
__export(search_exports, {
  blankNode: () => blankNode,
  getTypeLabel: () => getTypeLabel,
  getTypeLabelOptions: () => getTypeLabelOptions,
  indent: () => indent,
  newNodeFromField: () => newNodeFromField,
  newNodeFromType: () => newNodeFromType,
  oppositeJoin: () => oppositeJoin,
  randomString: () => randomString,
  transformNodeFromField: () => transformNodeFromField
});
module.exports = __toCommonJS(search_exports);
var import_futil = __toESM(require("futil"));
var import_fp = __toESM(require("lodash/fp.js"));
var import_schema = require("./schema.js");
let oppositeJoin = (node) => import_futil.default.getOrReturn("join", node) === "and" ? "or" : "and";
let randomString = () => Math.random().toString(36).substring(7);
let blankNode = () => ({ key: randomString() });
let newNodeFromType = import_fp.default.curry((type, fields, node) => ({
  type,
  ...import_fp.default.pick(["key", "field"], node),
  ...(0, import_schema.defaultNodeProps)(node.field, fields, type)
}));
let newNodeFromField = ({ field, fields, ...optionalNodeProps }) => {
  let type = import_fp.default.get([field, "typeDefault"], fields);
  return {
    type,
    field,
    ...(0, import_schema.defaultNodeProps)(field, fields, type),
    ...optionalNodeProps
  };
};
let transformNodeFromField = (args) => (node) => ({
  ...import_fp.default.pick("key", node),
  ...newNodeFromField(args)
});
let indent = (Tree, parent, node, skipDefaultNode) => {
  let join = (parent || node).join;
  let path = import_fp.default.toArray(node.path);
  let wrapperNode = {
    key: `${node.key}-${join}-group`,
    join: oppositeJoin(join)
  };
  let wrapperPath = [...import_fp.default.dropRight(1, path), wrapperNode.key];
  Tree.wrapInGroup(path, wrapperNode);
  if (!skipDefaultNode)
    Tree.add(wrapperPath, blankNode());
  return Tree.getNode(wrapperPath);
};
let getTypeLabel = (tree, type) => import_fp.default.getOr(import_futil.default.autoLabel(type), ["types", type, "label"], tree);
let getTypeLabelOptions = import_fp.default.curry(
  (tree, types) => import_fp.default.map((type) => ({ label: getTypeLabel(tree, type), value: type }), types)
);
