var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var theme_exports = {};
__export(theme_exports, {
  ThemeConsumer: () => ThemeConsumer,
  ThemeProvider: () => ThemeProvider,
  defaultTheme: () => defaultTheme,
  useTheme: () => useTheme,
  withTheme: () => withTheme
});
module.exports = __toCommonJS(theme_exports);
var import_react = __toESM(require("react"));
let inputType = (type) => (props) => /* @__PURE__ */ import_react.default.createElement("input", { type, ...props });
let defaultTheme = {
  Checkbox: inputType("checkbox"),
  DateInput: inputType("date"),
  NumberInput: inputType("number"),
  TextInput: inputType("text"),
  Box: "div",
  Root: "div",
  AlternateButton: "button",
  Button: "button",
  TextButton: "button",
  ButtonGroup: "div",
  Icon: "div",
  DropdownItem: "div",
  NestedPicker: "div",
  Modal: "dialog",
  Popover: "dialog",
  PagerItem: "span",
  RadioList: "div",
  Select: "select",
  Tag: "span",
  TextHighlight: "strong",
  Table: "table",
  Thead: "thead",
  Tbody: "tbody",
  Tfoot: "tfoot",
  Tr: "tr",
  Th: "th",
  Td: "td"
};
let ThemeContext = import_react.default.createContext(defaultTheme);
let ThemeProvider = ({ theme, children }) => {
  theme = { ...defaultTheme, ...theme };
  let Root = theme.Root || import_react.default.Fragment;
  return /* @__PURE__ */ import_react.default.createElement(ThemeContext.Provider, { value: theme }, /* @__PURE__ */ import_react.default.createElement(Root, null, children));
};
let useTheme = () => import_react.default.useContext(ThemeContext);
let ThemeConsumer = ({ children, theme }) => children({ ...useTheme(), ...theme });
let withTheme = (Component) => ({ theme, ...props }) => /* @__PURE__ */ import_react.default.createElement(Component, { theme: { ...useTheme(), ...theme }, ...props });
