import React from "react";
import PropTypes from "prop-types";
import { observer } from "mobx-react";
let margin = 24;
let styles = (mode) => ({
  display: "grid",
  gridGap: margin,
  margin: `0 ${margin}px`,
  marginBottom: margin,
  gridTemplateColumns: mode === "basic" ? "320px minmax(0, 1fr)" : "minmax(0, 1fr)"
});
let SearchLayout = ({ mode, style, className, ...props }) => /* @__PURE__ */ React.createElement(
  "div",
  {
    className: `search-layout search-layout-${mode} ${className}`,
    style: { ...styles(mode), ...style },
    ...props
  }
);
SearchLayout.propTypes = {
  mode: PropTypes.oneOf(["basic", "builder", "resultsOnly"])
};
var SearchLayout_default = observer(SearchLayout);
export {
  SearchLayout_default as default
};
