import _ from "lodash/fp.js";
import F from "futil";
import React from "react";
import { Column } from "../greyVest/ExpandableTable.js";
import { contexturify } from "../utils/hoc.js";
import TermsStatsTable from "./TermsStatsTable.js";
let CheckableTermsStatsTable = ({
  node,
  children,
  getValue,
  selected,
  theme: { Checkbox },
  ...props
}) => {
  let results = _.result("context.terms.slice", node) ?? _.result("context.results.slice", node);
  let allChecked = _.size(results) === _.size(F.view(selected));
  let checkAll = F.sets(
    allChecked ? [] : _.map(_.iteratee(getValue), results),
    selected
  );
  return /* @__PURE__ */ React.createElement(
    TermsStatsTable,
    {
      ...{
        ...props,
        children: [
          /* @__PURE__ */ React.createElement(
            Column,
            {
              key: "checkbox",
              label: /* @__PURE__ */ React.createElement(Checkbox, { checked: allChecked, onChange: checkAll }),
              display: (x, y) => /* @__PURE__ */ React.createElement(
                Checkbox,
                {
                  ...F.domLens.checkboxValues(_.iteratee(getValue)(y), selected)
                }
              )
            }
          ),
          ...children
        ]
      }
    }
  );
};
var CheckableTermsStatsTable_default = contexturify(CheckableTermsStatsTable);
export {
  CheckableTermsStatsTable_default as default
};
