import React from "react";
import _ from "lodash/fp.js";
import { contexturify } from "../utils/hoc.js";
let DateComponent = ({ tree, node, ranges, theme: { Select } }) => /* @__PURE__ */ React.createElement(
  Select,
  {
    value: (_.find({ range: node.range }, ranges) || {}).label,
    onChange: (event) => {
      let value = _.get("target.value", event);
      if (value) {
        let { range } = _.find({ label: value }, ranges);
        tree.mutate(node.path, {
          range,
          timezone: Intl.DateTimeFormat().resolvedOptions().timeZone
        });
      }
    },
    options: _.map((x) => ({ value: x.label, label: x.label }), ranges)
  }
);
DateComponent.displayName = "DateRangePicker";
var DateRangePicker_default = contexturify(DateComponent);
export {
  DateRangePicker_default as default
};
