import React from "react";
import F from "futil";
import _ from "lodash/fp.js";
import { contexturify } from "../utils/hoc.js";
import { toNumber } from "../utils/format.js";
import {
  displayFn,
  displayBlankFn,
  SelectAll,
  Cardinality,
  FacetCheckboxList,
  FacetOptionsFilter
} from "../utils/facet.js";
let maxChecked = 500;
let warningCheck = 250;
let Facet = ({
  tree,
  node,
  hide = {
    selectAll: false,
    // Hide the initial "Select All" checkbox
    radioList: false,
    // Hide the Include/Exclude radio list
    facetFilter: false,
    // Hide the search box above the facet checkboxes
    counts: false
    // Hide the facet counts so only the labels are displayed
  },
  display = displayFn,
  displayBlank = displayBlankFn,
  formatCount = toNumber,
  theme: { RadioList }
}) => {
  let valuesChecked = _.size(node.values);
  return /* @__PURE__ */ React.createElement("div", { className: "contexture-facet", "data-path": node.path }, valuesChecked > warningCheck && /* @__PURE__ */ React.createElement("span", null, "You have selected more than 250 items for this filter. Please consider using a different ", /* @__PURE__ */ React.createElement("b", null, "filter type"), " or contact support for more search options. You will not be able to select more than 500 items maximum."), !hide.radioList && /* @__PURE__ */ React.createElement(
    RadioList,
    {
      value: node.mode || "include",
      onChange: (mode) => tree.mutate(node.path, { mode }),
      options: F.autoLabelOptions(["include", "exclude"])
    }
  ), !hide.facetFilter && /* @__PURE__ */ React.createElement(FacetOptionsFilter, { tree, node }), !hide.selectAll && /* @__PURE__ */ React.createElement(SelectAll, { node, tree, maxChecked }), /* @__PURE__ */ React.createElement(
    FacetCheckboxList,
    {
      tree,
      node,
      hide,
      display,
      displayBlank,
      formatCount
    }
  ), /* @__PURE__ */ React.createElement(Cardinality, { ...{ node, tree } }));
};
var Facet_default = contexturify(Facet);
export {
  Facet_default as default
};
