import React from "react";
import F from "futil";
import _ from "lodash/fp.js";
import Async from "react-select/lib/Async.js";
import { components } from "react-select";
import { Flex } from "../greyVest/index.js";
import { contexturify } from "../utils/hoc.js";
import { Cardinality } from "../utils/facet.js";
let getOptions = (node) => _.map(
  ({ name, count }) => ({ ...F.autoLabelOption(name), count }),
  _.get("context.options", node)
);
let FacetSelect = ({
  tree,
  node,
  hide = {
    counts: false
    // Hide the facet counts so only the labels are displayed
  },
  singleValue = false,
  display = (x) => x,
  formatCount = (x) => x,
  displayBlank = () => /* @__PURE__ */ React.createElement("i", null, "Not Specified"),
  theme: { RadioList }
}) => {
  let MenuList = (props) => /* @__PURE__ */ React.createElement(components.MenuList, { ...props }, !!node.context.cardinality && /* @__PURE__ */ React.createElement(
    "div",
    {
      style: {
        boxShadow: "0 2px 2px -2px #CCC",
        fontSize: "0.9em",
        padding: "0 10px 1px",
        marginBottom: 4,
        opacity: 0.8
      }
    },
    /* @__PURE__ */ React.createElement(Cardinality, { ...{ node, tree } })
  ), props.children);
  return /* @__PURE__ */ React.createElement("div", { className: "contexture-facet-select", "data-path": node.path }, /* @__PURE__ */ React.createElement(
    RadioList,
    {
      value: node.mode || "include",
      onChange: (mode) => tree.mutate(node.path, { mode }),
      options: F.autoLabelOptions(["include", "exclude"])
    }
  ), /* @__PURE__ */ React.createElement(
    Async,
    {
      placeholder: "Search...",
      isMulti: !singleValue,
      cacheOptions: true,
      defaultOptions: getOptions(node),
      loadOptions: async (val) => {
        await tree.mutate(node.path, { optionsFilter: val });
        return getOptions(node);
      },
      formatOptionLabel: ({ label, count }, { context }) => /* @__PURE__ */ React.createElement(Flex, { justifyContent: "space-between" }, /* @__PURE__ */ React.createElement("span", null, display(label) || displayBlank()), context === "menu" && !hide.counts && /* @__PURE__ */ React.createElement("span", null, formatCount(count))),
      onChange: (x) => tree.mutate(node.path, { values: _.map("value", x) }),
      components: { MenuList }
    }
  ));
};
var FacetSelect_default = contexturify(FacetSelect);
export {
  FacetSelect_default as default
};
