import React from "react";
import _ from "lodash/fp.js";
import F from "futil";
import { Flex } from "../greyVest/index.js";
import { contexturify } from "../utils/hoc.js";
const customStyles = {
  valueContainer: (styles) => ({
    ...styles,
    ...{
      overflow: "hidden",
      textOverflow: "ellipsis"
    }
  })
};
const elementStyle = {
  flex: 1,
  marginBottom: "5px"
};
const operatorOptions = ["within", "not within"];
let GeoComponent = ({
  tree,
  node,
  loadOptions,
  GeoCodeLocation = _.noop,
  AutoComplete = null,
  placeholder = "Address ...",
  theme: { Select, NumberInput }
}) => /* @__PURE__ */ React.createElement(Flex, { style: { flexFlow: "column" } }, /* @__PURE__ */ React.createElement(
  Select,
  {
    style: elementStyle,
    value: node.operator,
    onChange: (e) => tree.mutate(node.path, { operator: e.target.value }),
    options: F.autoLabelOptions(operatorOptions)
  }
), /* @__PURE__ */ React.createElement("div", { style: elementStyle }, /* @__PURE__ */ React.createElement(
  NumberInput,
  {
    min: "1",
    value: node.radius,
    onChange: (e) => tree.mutate(node.path, { radius: e.target.value }),
    placeholder: "Enter number of miles ..."
  }
), " ", "from"), /* @__PURE__ */ React.createElement("div", { style: elementStyle }, AutoComplete && /* @__PURE__ */ React.createElement(
  AutoComplete,
  {
    cacheOptions: true,
    escapeClearsValue: true,
    defaultInputValue: node.location,
    placeholder,
    noOptionsMessage: () => "",
    menuPortalTarget: document.body,
    menuShouldScrollIntoView: true,
    styles: customStyles,
    loadOptions,
    onInputChange: (newValue) => newValue.replace(/[^a-zA-Z0-9\s]+/g, ""),
    onChange: async ({ label, value }) => {
      let { latitude, longitude } = await GeoCodeLocation(value) || {};
      if (latitude && longitude) {
        tree.mutate(node.path, {
          latitude,
          longitude,
          location: label
        });
      }
    }
  }
), !AutoComplete && /* @__PURE__ */ React.createElement("div", null, "Autocomplete component is required!")));
var Geo_default = contexturify(GeoComponent);
export {
  Geo_default as default
};
