import React from "react";
import _ from "lodash/fp.js";
import l from "lodash";
import { Flex } from "../greyVest/index.js";
import { contexturify } from "../utils/hoc.js";
let NumberComponent = ({
  tree,
  node,
  showBestRange = false,
  formatter = _.identity,
  significantDigits,
  theme: { NumberInput, Button }
}) => /* @__PURE__ */ React.createElement("div", { className: "contexture-number", "data-path": node.path }, /* @__PURE__ */ React.createElement(Flex, { style: { alignItems: "center" } }, /* @__PURE__ */ React.createElement(
  NumberInput,
  {
    value: formatter(node.min) || "",
    onChange: (e) => tree.mutate(node.path, {
      min: _.isNumber(significantDigits) ? _.toString(l.round(e.target.value, significantDigits)) : e.target.value
    })
  }
), /* @__PURE__ */ React.createElement("div", { className: "contexture-number-separator" }, "-"), /* @__PURE__ */ React.createElement(
  NumberInput,
  {
    value: formatter(node.max) || "",
    onChange: (e) => tree.mutate(node.path, {
      max: _.isNumber(significantDigits) ? _.toString(l.round(e.target.value, significantDigits)) : e.target.value
    })
  }
)), showBestRange && /* @__PURE__ */ React.createElement("div", { className: "contexture-number-best-range" }, /* @__PURE__ */ React.createElement(
  Button,
  {
    style: { width: "100%" },
    onClick: async () => {
      await tree.mutate(node.path, { findBestRange: true });
      let { min, max } = _.get("context.bestRange", node);
      if (_.isNumber(significantDigits)) {
        min = l.round(min, significantDigits);
        max = l.round(max, significantDigits);
      }
      tree.mutate(node.path, {
        findBestRange: false,
        min,
        max
      });
    }
  },
  "Find best range"
)));
NumberComponent.displayName = "Number";
var Number_default = contexturify(NumberComponent);
export {
  Number_default as default
};
