import React from "react";
import _ from "lodash/fp.js";
import { observer } from "mobx-react";
import TagsJoinPicker from "../TagsJoinPicker.js";
import { withTheme } from "../../utils/theme.js";
import { Flex } from "../../greyVest/index.js";
import { copyTags, tagTerm } from "./utils.js";
let ActionsMenu = ({
  node,
  tree,
  close,
  theme: { Button, Checkbox },
  actionWrapper = _.identity,
  joinOptions
}) => /* @__PURE__ */ React.createElement(
  Flex,
  {
    style: { minWidth: 240, padding: 10 },
    className: "tags-query-actions-menu",
    column: true,
    justifyContent: "stretch",
    alignItems: "stretch"
  },
  !!_.get("tags.length", node) && /* @__PURE__ */ React.createElement(React.Fragment, null, /* @__PURE__ */ React.createElement(Button, { onClick: actionWrapper(() => close() || copyTags(node)) }, "Copy ", _.startCase(tagTerm), "s"), /* @__PURE__ */ React.createElement(
    Button,
    {
      style: { margin: "10px 0" },
      onClick: actionWrapper(
        () => close() || tree.mutate(node.path, { tags: [] })
      )
    },
    "Clear ",
    _.startCase(tagTerm),
    "s"
  ), /* @__PURE__ */ React.createElement("div", { className: "line-separator" })),
  /* @__PURE__ */ React.createElement("label", { className: "labeled-checkbox", style: { margin: "10px 0" } }, /* @__PURE__ */ React.createElement(
    Checkbox,
    {
      htmlId: "stemming",
      checked: !node.exact,
      onChange: (e) => tree.mutate(node.path, { exact: !e.target.checked })
    }
  ), /* @__PURE__ */ React.createElement("span", null, "Include word variations")),
  /* @__PURE__ */ React.createElement("div", null, /* @__PURE__ */ React.createElement(TagsJoinPicker, { ...{ node, tree, joinOptions } }))
);
var ActionsMenu_default = _.flow(observer, withTheme)(ActionsMenu);
export {
  ActionsMenu_default as default
};
