import _ from "lodash/fp.js";
import { bgJoin } from "../../styles/generic.js";
import { tagToGroupJoin } from "../TagsJoinPicker.js";
let tagTerm = "keyword";
let tagValueField = "word";
let copyTags = (node) => {
  if (node.tags) {
    let words = _.flow(_.map(tagValueField), _.reverse, _.join(","))(node.tags);
    navigator.clipboard.writeText(words);
  }
};
let getTag = (tag, node = {}, key = tagValueField) => _.find({ [key]: tag }, node.tags) || {};
let getTagStyle = (node, key) => (tag) => {
  let tagInstance = getTag(tag, node, key);
  return {
    ...tagInstance.distance ? {} : { fontWeight: "bold" },
    ...bgJoin(tagToGroupJoin(_.get("join", node))),
    opacity: tagInstance.onlyShowTheseResults || !_.find("onlyShowTheseResults", node.tags) ? 1 : 0.5
  };
};
let convertWordToTag = (word, label = "") => ({
  [tagValueField]: word,
  label,
  distance: 3
});
export {
  convertWordToTag,
  copyTags,
  getTag,
  getTagStyle,
  tagTerm,
  tagValueField
};
