import React from "react";
import _ from "lodash/fp.js";
import { observer } from "mobx-react";
import Flex from "./Flex.js";
let YAxis = ({ height, borderColor, min, max }) => /* @__PURE__ */ React.createElement("div", null, /* @__PURE__ */ React.createElement(
  "div",
  {
    key: "legend",
    style: {
      height,
      margin: "0 5px",
      display: "flex",
      flexDirection: "column",
      justifyContent: "space-between",
      borderRight: `solid 1px ${borderColor()}`,
      padding: "5px"
    }
  },
  /* @__PURE__ */ React.createElement(
    "div",
    {
      style: {
        borderTop: `solid 1px ${borderColor()}`,
        textAlign: "right"
      }
    },
    max
  ),
  /* @__PURE__ */ React.createElement(
    "div",
    {
      style: {
        borderBottom: `solid 1px ${borderColor()}`,
        textAlign: "right"
      }
    },
    min
  )
), /* @__PURE__ */ React.createElement("div", { style: { padding: "5px" } }, "\xA0"));
let BarChart = ({
  data,
  valueField,
  categoryField,
  background = () => "#ccc",
  height = 100,
  format = _.identity,
  gutter = 5,
  yAxis = false
}) => {
  let values = _.map(valueField, data);
  let max = _.max(values);
  let min = _.min(values);
  return /* @__PURE__ */ React.createElement(Flex, { style: { alignItems: "flex-end", justifyContent: "center" } }, yAxis && !!data.length && /* @__PURE__ */ React.createElement(YAxis, { ...{ min, max, height, borderColor: background } }), _.map(
    (x) => /* @__PURE__ */ React.createElement("div", { key: x.key }, /* @__PURE__ */ React.createElement(
      "div",
      {
        style: {
          height: x[valueField] / max * height,
          background: background(x, max),
          margin: `0 ${gutter}px`
        },
        title: x[valueField]
      },
      "\xA0"
    ), /* @__PURE__ */ React.createElement("div", { style: { padding: "5px" } }, format(x[categoryField]))),
    data
  ));
};
var BarChart_default = observer(BarChart);
export {
  BarChart_default as default
};
