import React from "react";
import { observer } from "mobx-react";
import moment from "moment";
import DatePicker from "react-date-picker/dist/entry.nostyle.js";
import _ from "lodash/fp.js";
let NativeDateInput = ({ value, onChange, ...props }) => /* @__PURE__ */ React.createElement(
  "input",
  {
    type: "date",
    value: value ? moment(value).format("YYYY-MM-DD") : "",
    onChange: (e) => onChange(new Date(e.target.value)),
    ...props
  }
);
let ReactDatePickerInput = ({
  value,
  calendarIcon = null,
  clearIcon = null,
  ...props
}) => /* @__PURE__ */ React.createElement(
  DatePicker,
  {
    calendarType: "US",
    calendarIcon,
    clearIcon,
    value: _.isDate(value) || _.isEmpty(value) ? value : new Date(value),
    ...props
  }
);
let DateInput = ({ value, native = false, ...props }) => native ? /* @__PURE__ */ React.createElement(NativeDateInput, { value, ...props }) : /* @__PURE__ */ React.createElement(ReactDatePickerInput, { value, ...props });
var DateInput_default = observer(DateInput);
export {
  DateInput_default as default
};
