import React from "react";
import Flex from "./Flex.js";
import { withTheme } from "../utils/theme.js";
let Expandable = ({
  isOpen,
  className,
  style,
  Label,
  children,
  onClick,
  theme: { Icon }
}) => /* @__PURE__ */ React.createElement(
  "div",
  {
    className: `gv-expandable ${isOpen ? "expanded" : ""} ${className}`,
    style
  },
  /* @__PURE__ */ React.createElement(
    Flex,
    {
      className: "gv-expandable-header",
      alignItems: "center",
      onClick
    },
    /* @__PURE__ */ React.createElement("div", { style: { flexGrow: 1 } }, Label),
    /* @__PURE__ */ React.createElement("div", { className: `gv-expandable-icon ${isOpen ? "expanded" : ""}` }, /* @__PURE__ */ React.createElement(Icon, { icon: "FilterListExpand" }))
  ),
  /* @__PURE__ */ React.createElement("div", { className: `gv-expandable-body ${isOpen ? "expanded" : ""}` }, children)
);
var Expandable_default = withTheme(Expandable);
export {
  Expandable_default as default
};
