import React from "react";
import { Dynamic } from "../greyVest/index.js";
import TextButton from "./TextButton.js";
let SmallIcon = ({ icon, style, ...props }) => /* @__PURE__ */ React.createElement("i", { className: "material-icons", style: { fontSize: 20, ...style }, ...props }, icon);
let toIcon = (id) => (props) => /* @__PURE__ */ React.createElement(SmallIcon, { icon: id, ...props });
let iconMap = {
  SortAscending: toIcon("expand_less"),
  SortDescending: toIcon("expand_more"),
  MoveLeft: toIcon("chevron_left"),
  MoveRight: toIcon("chevron_right"),
  RemoveColumn: toIcon("remove"),
  AddColumn: toIcon("add"),
  FilterExpand: toIcon("filter_alt"),
  FilterCollapse: toIcon("filter_list"),
  FilterAdd: toIcon("filter_list"),
  TableColumnMenu: () => /* @__PURE__ */ React.createElement(TextButton, null, /* @__PURE__ */ React.createElement(SmallIcon, { icon: "more_vert" })),
  FilterListExpand: toIcon("keyboard_arrow_down"),
  FilterListCollapse: toIcon("keyboard_arrow_up"),
  TreePause: toIcon("unfold_less"),
  TreeUnpause: toIcon("unfold_more"),
  PreviousPage: toIcon("chevron_left"),
  NextPage: toIcon("chevron_right"),
  Previous5Pages: () => /* @__PURE__ */ React.createElement("span", null, "..."),
  Next5Pages: () => /* @__PURE__ */ React.createElement("span", null, "..."),
  Refresh: () => /* @__PURE__ */ React.createElement(
    TextButton,
    {
      className: "animated pulse slow infinite",
      style: { animationDuration: "500ms" }
    },
    /* @__PURE__ */ React.createElement(SmallIcon, { icon: "refresh" })
  ),
  AutoUpdate: toIcon("autorenew"),
  New: toIcon("fiber_new"),
  Expand: toIcon("keyboard_arrow_down")
};
let Icon = ({ icon, ...props }) => /* @__PURE__ */ React.createElement(Dynamic, { component: iconMap[icon] || toIcon(icon), ...props });
var Icon_default = Icon;
export {
  Icon_default as default
};
