import React from "react";
import _ from "lodash/fp.js";
import { observer } from "mobx-react";
import Portal from "./Portal.js";
import { openBinding } from "./utils.js";
import { expandProp } from "../utils/react.js";
let Modal = ({ isOpen, onClose, children, style = {}, className = "" }) => /* @__PURE__ */ React.createElement(Portal, null, isOpen && /* @__PURE__ */ React.createElement(
  "div",
  {
    style: {
      position: "fixed",
      top: 0,
      bottom: 0,
      left: 0,
      right: 0,
      backgroundColor: "rgba(0,0,0,0.3)",
      padding: 50,
      overflowY: "auto",
      zIndex: 1e3,
      display: "flex",
      justifyContent: "space-around",
      alignItems: "flex-start"
    },
    onClick: onClose,
    className: `default-modal-bg ${className}`
  },
  /* @__PURE__ */ React.createElement(
    "div",
    {
      style: {
        backgroundColor: "#fff",
        ...style
      },
      onClick: (e) => e.stopPropagation(),
      className: "default-modal-wrap"
    },
    children
  )
));
var Modal_default = _.flow(expandProp("open", openBinding), observer)(Modal);
export {
  Modal_default as default
};
