import _ from "lodash/fp.js";
import React from "react";
import GVPagerItem from "./PagerItem.js";
import Flex from "./Flex.js";
import { withTheme } from "../utils/theme.js";
let Pager = ({
  value,
  onChange = () => {
  },
  pageCount,
  PagerItem = GVPagerItem,
  disabled = false,
  theme: { Icon }
}) => pageCount > 1 && /* @__PURE__ */ React.createElement(Flex, { justifyContent: "center", alignItems: "center" }, /* @__PURE__ */ React.createElement(
  PagerItem,
  {
    disabled: disabled || !(value > 1),
    onClick: () => onChange(value - 1)
  },
  /* @__PURE__ */ React.createElement(Icon, { icon: "PreviousPage" })
), value > 3 && /* @__PURE__ */ React.createElement(
  PagerItem,
  {
    disabled,
    onClick: () => onChange(_.max([0, value - 5]))
  },
  /* @__PURE__ */ React.createElement(Icon, { icon: "Previous5Pages" })
), _.reverse(
  _.times(
    (n) => value > n + 1 && /* @__PURE__ */ React.createElement(
      PagerItem,
      {
        disabled,
        key: `prev${n}`,
        onClick: () => onChange(value - (n + 1))
      },
      value - (n + 1)
    ),
    2
  )
), /* @__PURE__ */ React.createElement(PagerItem, { disabled, active: true }, value), _.times(
  (n) => value + (n + 1) <= pageCount && /* @__PURE__ */ React.createElement(
    PagerItem,
    {
      disabled,
      key: `next${n}`,
      onClick: () => onChange(value + (n + 1))
    },
    value + (n + 1)
  ),
  2
), value + 2 < pageCount && /* @__PURE__ */ React.createElement(
  PagerItem,
  {
    disabled,
    onClick: () => onChange(_.min([pageCount, value + 5]))
  },
  /* @__PURE__ */ React.createElement(Icon, { icon: "Next5Pages" })
), /* @__PURE__ */ React.createElement(
  PagerItem,
  {
    disabled: disabled || !(value < pageCount),
    onClick: () => onChange(value + 1)
  },
  /* @__PURE__ */ React.createElement(Icon, { icon: "NextPage" })
));
var Pager_default = withTheme(Pager);
export {
  Pager_default as default
};
