import React from "react";
import _ from "lodash/fp.js";
import F from "futil";
import { Popup } from "reactjs-popup";
import { openBinding } from "./utils.js";
import { explodeProp } from "../utils/react.js";
let Popover = ({
  trigger,
  isOpen,
  onClose,
  arrow,
  position,
  closeOnDocumentClick = true,
  closeOnPopoverClick = true,
  arrowStyle,
  contentStyle,
  style,
  children,
  ...props
}) => /* @__PURE__ */ React.createElement(
  Popup,
  {
    trigger: (open) => /* @__PURE__ */ React.createElement("span", null, F.callOrReturn(trigger, open)),
    open: isOpen,
    onClose,
    arrow,
    position: position || "bottom left",
    closeOnDocumentClick,
    nested: true,
    keepTooltipInside: true,
    arrowStyle: {
      filter: "drop-shadow(0 -4px 3px rgba(39, 44, 65, 0.1)",
      ...arrowStyle
    },
    contentStyle: {
      background: "#FFF",
      borderRadius: 3,
      border: "1px solid rgb(235, 235, 235)",
      boxShadow: "0 2px 10px 0 rgba(39, 44, 65, 0.1)",
      padding: 5,
      ...contentStyle,
      ...style
    },
    ...props
  },
  (close) => /* @__PURE__ */ React.createElement("div", { onClick: closeOnPopoverClick ? close : null }, _.isFunction(children) ? children(close) : children)
);
var Popover_default = explodeProp("open", openBinding)(Popover);
export {
  Popover_default as default
};
