import React from "react";
import _ from "lodash/fp.js";
import { observer } from "mobx-react";
let RadioList = ({
  options,
  value,
  onChange,
  className = "",
  native = false,
  ...props
}) => /* @__PURE__ */ React.createElement("div", { className: `gv-radio-list ${className}`, ...props }, _.map(
  (option) => /* @__PURE__ */ React.createElement(
    "label",
    {
      className: "gv-radio-option",
      key: option.value,
      style: { cursor: "pointer", marginRight: 25 }
    },
    /* @__PURE__ */ React.createElement(
      "input",
      {
        type: "radio",
        style: {
          marginRight: 10,
          display: native ? "inline-block" : "none",
          width: "auto",
          height: "auto"
        },
        onChange: () => onChange(option.value),
        value: option.value,
        checked: value === option.value
      }
    ),
    native ? option.label : /* @__PURE__ */ React.createElement(React.Fragment, null, /* @__PURE__ */ React.createElement("div", { className: "gv-radio" }, /* @__PURE__ */ React.createElement(
      "div",
      {
        className: `gv-radio-dot ${value === option.value ? "active" : ""}`
      }
    )), /* @__PURE__ */ React.createElement("div", { className: "gv-radio-label" }, option.label))
  ),
  options
));
var RadioList_default = observer(RadioList);
export {
  RadioList_default as default
};
