import React, { useState } from "react";
import _ from "lodash/fp.js";
import F from "futil";
import TabList from "./TabList.js";
import Box from "./Box.js";
let TabContent = () => {
};
let TabLabel = () => {
};
let Tab = () => {
};
let Tabs = ({
  children,
  onChange = _.noop,
  TabsList = TabList,
  TabPanel = Box,
  defaultValue,
  ...props
}) => {
  let childrenArray = React.Children.toArray(children);
  let options = _.flow(
    _.filter((child) => child.type === Tab || child.type === TabLabel),
    F.mapIndexed(({ type, props: props2 }, i) => ({
      value: props2.value || i,
      label: type === Tab ? props2.label : props2.children
    }))
  )(childrenArray);
  let [value, setValue] = useState(defaultValue || options[0].value);
  if (!_.isNil(props.value) && props.value !== value)
    setValue(props.value);
  let handleChange = (to, from) => {
    onChange(to, from);
    setValue(to);
  };
  let content = _.flow(
    _.filter.convert({ cap: false })(
      ({ type, props: props2 }, i) => (type === Tab || type === TabContent) && (value === props2.value || value === i)
    ),
    F.mapIndexed(({ props: props2 }, i) => /* @__PURE__ */ React.createElement(React.Fragment, { key: i }, F.callOrReturn(props2.children, value)))
  )(childrenArray);
  return /* @__PURE__ */ React.createElement(React.Fragment, null, /* @__PURE__ */ React.createElement(TabsList, { value, onChange: handleChange, options }), /* @__PURE__ */ React.createElement(TabPanel, null, content));
};
export {
  Tab,
  TabContent,
  TabLabel,
  Tabs
};
