import F from "futil";
import _ from "lodash/fp.js";
import React from "react";
import { observer } from "mobx-react";
import { withTheme } from "../utils/theme.js";
let ModalPicker = ({
  options = [],
  className = "",
  modalClassName = "",
  onChange,
  label,
  theme: { Button, NestedPicker, Modal },
  ...props
}) => {
  let open = React.useState(false);
  return !!options.length && /* @__PURE__ */ React.createElement(React.Fragment, null, /* @__PURE__ */ React.createElement(Modal, { open, className: modalClassName }, /* @__PURE__ */ React.createElement(
    NestedPicker,
    {
      options,
      onChange: (x) => {
        onChange(x);
        F.off(open)();
      },
      ...props
    }
  )), /* @__PURE__ */ React.createElement(
    Button,
    {
      className: `modal-picker-button ${className}`,
      onClick: F.on(open)
    },
    label
  ));
};
var ModalPicker_default = _.flow(observer, withTheme)(ModalPicker);
export {
  ModalPicker_default as default
};
