import _ from "lodash/fp.js";
import F from "futil";
import { observer } from "mobx-react";
import React from "react";
import { setDisplayName } from "react-recompose";
import { Flex } from "../greyVest/index.js";
import { withTheme } from "../utils/theme.js";
let Buttons = _.flow(
  setDisplayName("Buttons"),
  observer,
  withTheme
)(({ step, totalSteps, currentStep, onSubmit, theme: { Button, Icon } }) => /* @__PURE__ */ React.createElement(React.Fragment, null, step > 0 && /* @__PURE__ */ React.createElement(Button, { onClick: F.sets(step - 1, currentStep), className: "back-button" }, /* @__PURE__ */ React.createElement(Icon, { icon: "PreviousPage" }), "Back"), step < totalSteps - 1 ? /* @__PURE__ */ React.createElement(Button, { primary: true, onClick: F.sets(step + 1, currentStep), disabled: false }, "Continue") : /* @__PURE__ */ React.createElement(Button, { primary: true, onClick: onSubmit }, "View Results")));
let AccordionStep = _.flow(
  setDisplayName("AccordionStep"),
  withTheme
)(
  ({
    style,
    className,
    step,
    totalSteps,
    currentStep,
    title,
    isRequired = false,
    onSubmit,
    children,
    theme: { Icon }
  }) => {
    let open = F.view(currentStep) === step;
    return /* @__PURE__ */ React.createElement("div", { className: `accordion-step ${className || ""}`, style }, /* @__PURE__ */ React.createElement(
      Flex,
      {
        alignItems: "center",
        justifyContent: "space-between",
        onClick: F.sets(open ? -1 : step, currentStep),
        style: { cursor: "pointer" }
      },
      /* @__PURE__ */ React.createElement(Flex, { alignItems: "center" }, /* @__PURE__ */ React.createElement("div", { className: "accordion-step-title" }, F.callOrReturn(title, step)), !isRequired && /* @__PURE__ */ React.createElement("em", { style: { marginLeft: 6 } }, "(Optional)")),
      /* @__PURE__ */ React.createElement("div", { className: "filter-field-label-icon" }, /* @__PURE__ */ React.createElement(Icon, { icon: open ? "FilterListCollapse" : "FilterListExpand" }))
    ), open && /* @__PURE__ */ React.createElement(React.Fragment, null, /* @__PURE__ */ React.createElement("div", { className: "step-contents" }, children), /* @__PURE__ */ React.createElement(Buttons, { ...{ step, totalSteps, currentStep, onSubmit } })));
  }
);
let StepsAccordion = ({ onSubmit = _.noop, children, className, ...props }) => {
  let currentStep = React.useState(0);
  return /* @__PURE__ */ React.createElement("div", { className: `steps-accordion ${className || ""}`, ...props }, React.Children.map(children, (child, i) => /* @__PURE__ */ React.createElement(
    child.type,
    {
      ...{ currentStep, onSubmit },
      key: i,
      step: i,
      totalSteps: _.size(children),
      ...child.props
    }
  )));
};
var StepsAccordion_default = StepsAccordion;
export {
  AccordionStep,
  StepsAccordion_default as default
};
