import _ from "lodash/fp.js";
import F from "futil";
import React from "react";
import { setDisplayName } from "react-recompose";
import FilterButtonList from "../FilterButtonList.js";
import { StepsAccordion, AccordionStep } from "../purgatory/index.js";
import { withNode } from "../utils/hoc.js";
import { withTheme } from "../utils/theme.js";
let generateStepTitle = (node, title) => (i) => /* @__PURE__ */ React.createElement("h1", null, /* @__PURE__ */ React.createElement("span", { className: "step-number" }, "Step ", i + 1, " - "), i === 0 ? `Search for ${title || "Results"} by...` : i < _.size(node.children) - 1 ? `And...` : `Narrow Your Results`);
let QueryWizard = _.flow(
  setDisplayName("QueryWizard"),
  withNode,
  withTheme
)(
  ({
    tree,
    node,
    fields = {},
    title,
    onSubmit = _.noop,
    mapNodeToProps = _.noop,
    style
  }) => /* @__PURE__ */ React.createElement(StepsAccordion, { ...{ style, onSubmit } }, F.mapIndexed(
    (child, i) => /* @__PURE__ */ React.createElement(
      AccordionStep,
      {
        key: i,
        isRequired: i === 0,
        title: generateStepTitle(node, title)
      },
      /* @__PURE__ */ React.createElement(
        FilterButtonList,
        {
          ...{
            node: child,
            tree,
            fields,
            mapNodeToProps
          },
          key: node.key
        }
      )
    ),
    _.get("children", node)
  ))
);
var QueryWizard_default = QueryWizard;
export {
  QueryWizard_default as default
};
