let dFlex = {
  display: "flex"
};
let flexJustifyContentBetween = {
  justifyContent: "space-between",
  ...dFlex
};
let w100 = {
  width: "100%"
};
let fullscreen = {
  position: "fixed",
  top: 0,
  left: 0,
  bottom: 0,
  right: 0
};
let roundedLeft0 = {
  borderTopLeftRadius: 0,
  borderBottomLeftRadius: 0
};
let roundedRight0 = {
  borderTopRightRadius: 0,
  borderBottomRightRadius: 0
};
let bgStriped = {
  backgroundImage: "linear-gradient(-45deg, rgba(200, 200, 200, 0.2) 25%, transparent 25%, transparent 50%, rgba(200, 200, 200, 0.2) 50%, rgba(200, 200, 200, 0.2) 75%, transparent 75%, transparent",
  backgroundSize: "1rem 1rem"
};
let loading = {
  ...bgStriped,
  opacity: 0.5
};
let joinColor = (join) => ({
  and: "#5bc0de",
  or: "#5cb85c",
  not: "#d9534f"
})[join?.join || join];
let bgJoin = (tree) => ({
  background: joinColor(tree),
  color: "white"
});
let bdJoin = (tree) => ({
  borderColor: joinColor(tree)
});
let bgPreview = (join) => ({
  opacity: 0.7,
  ...bgJoin(join),
  ...bgStriped
});
var generic_default = {
  // Layout
  dFlex,
  flexJustifyContentBetween,
  w100,
  fullscreen,
  // Button
  roundedLeft0,
  roundedRight0,
  // Misc
  bgStriped,
  // Search
  joinColor,
  bgJoin,
  bdJoin,
  bgPreview
};
export {
  bdJoin,
  bgJoin,
  bgPreview,
  bgStriped,
  dFlex,
  generic_default as default,
  flexJustifyContentBetween,
  fullscreen,
  joinColor,
  loading,
  roundedLeft0,
  roundedRight0,
  w100
};
