import React from "react";
import { Dynamic } from "../../greyVest/index.js";
let toIcon = (symbol) => (props) => /* @__PURE__ */ React.createElement("span", { ...props }, symbol);
let iconMap = {
  SortAscending: toIcon("\u25B2"),
  SortDescending: toIcon("\u25BC"),
  MoveLeft: toIcon("\u2190"),
  MoveRight: toIcon("\u2192"),
  RemoveColumn: toIcon("x"),
  AddColumn: toIcon("+"),
  FilterExpand: toIcon(">"),
  FilterCollapse: toIcon("V"),
  FilterAdd: toIcon("+"),
  TableColumnMenu: toIcon(`${String.fromCharCode(160)}:`),
  FilterListExpand: toIcon("\u25C0"),
  FilterListCollapse: toIcon("\u25BC"),
  TreePause: toIcon("\u2296"),
  TreeUnpause: toIcon("\u2295"),
  NextPage: toIcon("\u2192"),
  PreviousPage: toIcon("\u2190"),
  Previous5Pages: toIcon("\u21DC"),
  Next5Pages: toIcon("\u21DD"),
  Refresh: toIcon("\u27F3"),
  AutoUpdate: ({ style, ...props }) => /* @__PURE__ */ React.createElement(
    "span",
    {
      style: { display: "inline-flex", flexDirection: "column", ...style },
      ...props
    },
    /* @__PURE__ */ React.createElement("span", { style: { lineHeight: "0.8em" } }, "\u293A"),
    /* @__PURE__ */ React.createElement("span", { style: { lineHeight: "1.2em", marginTop: "-0.5em" } }, "\u293B")
  ),
  New: () => /* @__PURE__ */ React.createElement(
    "span",
    {
      style: {
        fontSize: "0.6em",
        padding: "0.5em 0.2em"
      }
    },
    "NEW"
  ),
  Expand: toIcon("v")
};
let DefaultIcon = ({ icon, ...props }) => /* @__PURE__ */ React.createElement(Dynamic, { component: iconMap[icon], ...props });
var Icon_default = DefaultIcon;
export {
  Icon_default as default,
  iconMap
};
