import F from "futil";
import React from "react";
import { defaultProps } from "react-recompose";
import {
  BarChart,
  Modal,
  NestedPicker,
  Popover,
  RadioList,
  Select,
  TagsInput,
  Tag,
  TextHighlight,
  DateInput
} from "../../greyVest/index.js";
import Icon from "./Icon.js";
import UnmappedNodeComponent from "./UnmappedNodeComponent.js";
import { defaultTheme } from "../../utils/theme.js";
let theme = {
  AlternateButton: "button",
  BarChart,
  Box: "div",
  Button: "button",
  ButtonGroup: "div",
  Checkbox: (props) => /* @__PURE__ */ React.createElement("input", { type: "checkbox", ...props }),
  DateInput: defaultProps({ native: true })(DateInput),
  UnmappedNodeComponent,
  Icon,
  Input: "input",
  DropdownItem: "li",
  Modal,
  NumberInput: (props) => /* @__PURE__ */ React.createElement("input", { type: "number", ...props }),
  NestedPicker,
  PagerItem: ({ children }) => /* @__PURE__ */ React.createElement("span", null, children),
  Popover,
  RadioList: defaultProps({ native: true })(RadioList),
  Select,
  Table: "table",
  Tag,
  TagsInput,
  TextHighlight,
  TextInput: "input"
};
F.mergeOn(defaultTheme, theme);
var base_default = theme;
export {
  base_default as default
};
