import React from "react";
import F from "futil";
import { observer } from "mobx-react";
let PagerItem = ({ active, disabled, style = {}, ...props }) => {
  let hovering = React.useState(false);
  return /* @__PURE__ */ React.createElement(
    "span",
    {
      style: {
        padding: "5px",
        background: F.view(hovering) || disabled ? "#f5f5f5" : "white",
        border: "2px solid #EDEDED",
        borderRadius: "4px",
        ...active && {
          fontWeight: "bold",
          borderColor: "#0076DE",
          color: "#0076DE"
        },
        ...disabled && {
          pointerEvents: "none"
        },
        cursor: disabled ? "not-allowed" : "pointer",
        ...style
      },
      ...F.domLens.hover(hovering),
      ...props
    }
  );
};
var PagerItem_default = observer(PagerItem);
export {
  PagerItem,
  PagerItem_default as default
};
