import React from "react";
import { observer } from "mobx-react";
import { Flex, Checkbox } from "../../greyVest/index.js";
let PickerItem = ({
  active,
  disabled,
  hasChildren,
  isChecked,
  onClick,
  children,
  ...props
}) => /* @__PURE__ */ React.createElement(
  "div",
  {
    style: {
      padding: "10px",
      cursor: "pointer",
      fontSize: 18,
      background: active ? "#ebebeb" : "#fff",
      color: disabled ? "#9b9b9b" : "#000"
    },
    onClick,
    ...props
  },
  hasChildren ? /* @__PURE__ */ React.createElement(Flex, { style: { alignItems: "center" } }, children, /* @__PURE__ */ React.createElement("i", { className: "material-icons", style: { fontSize: 20 } }, "chevron_right")) : /* @__PURE__ */ React.createElement(Flex, null, /* @__PURE__ */ React.createElement(
    Checkbox,
    {
      checked: isChecked,
      onChange: onClick,
      style: { marginRight: 10 }
    }
  ), children)
);
var PickerItem_default = observer(PickerItem);
export {
  PickerItem_default as default
};
