import React from "react";
import { observer } from "mobx-react";
import ChipInput from "material-ui-chip-input";
import MaterialTag from "./Tag.js";
let TagsInput = ({
  tags,
  addTag,
  removeTag,
  onTagClick,
  tagStyle,
  placeholder = "Search...",
  Tag = MaterialTag,
  style
}) => /* @__PURE__ */ React.createElement(
  ChipInput,
  {
    onAdd: addTag,
    onDelete: removeTag,
    placeholder,
    value: tags,
    chipRenderer: ({ value }) => /* @__PURE__ */ React.createElement(
      Tag,
      {
        onClick: () => onTagClick(value),
        removeTag,
        value,
        style: { marginRight: 4 },
        tagStyle
      }
    ),
    style,
    fullWidth: true,
    alwaysShowPlaceholder: true
  }
);
var TagsInput_default = observer(TagsInput);
export {
  TagsInput_default as default
};
