import _ from "lodash/fp.js";
import F from "futil";
import { useState } from "react";
import { mapProps } from "react-recompose";
let useLensObject = _.mapValues(useState);
let getDisplayName = (Component) => F.cascade(["displayName", "name"], Component) || "Unknown";
let wrapDisplayName = (name, Component) => (Wrapped) => {
  Wrapped.displayName = `${name}(${getDisplayName(Component)})`;
  return Wrapped;
};
let expandProp = _.flow(
  (key, fn) => F.expandObjectBy(key, F.whenExists(fn)),
  mapProps
);
let explodeProp = _.flow(
  (key, fn) => _.flow(F.expandObjectBy(key, F.whenExists(fn)), _.omit(key)),
  mapProps
);
export {
  expandProp,
  explodeProp,
  getDisplayName,
  useLensObject,
  wrapDisplayName
};
