import React from "react";
let inputType = (type) => (props) => /* @__PURE__ */ React.createElement("input", { type, ...props });
let defaultTheme = {
  Checkbox: inputType("checkbox"),
  DateInput: inputType("date"),
  NumberInput: inputType("number"),
  TextInput: inputType("text"),
  Box: "div",
  Root: "div",
  AlternateButton: "button",
  Button: "button",
  TextButton: "button",
  ButtonGroup: "div",
  Icon: "div",
  DropdownItem: "div",
  NestedPicker: "div",
  Modal: "dialog",
  Popover: "dialog",
  PagerItem: "span",
  RadioList: "div",
  Select: "select",
  Tag: "span",
  TextHighlight: "strong",
  Table: "table",
  Thead: "thead",
  Tbody: "tbody",
  Tfoot: "tfoot",
  Tr: "tr",
  Th: "th",
  Td: "td"
};
let ThemeContext = React.createContext(defaultTheme);
let ThemeProvider = ({ theme, children }) => {
  theme = { ...defaultTheme, ...theme };
  let Root = theme.Root || React.Fragment;
  return /* @__PURE__ */ React.createElement(ThemeContext.Provider, { value: theme }, /* @__PURE__ */ React.createElement(Root, null, children));
};
let useTheme = () => React.useContext(ThemeContext);
let ThemeConsumer = ({ children, theme }) => children({ ...useTheme(), ...theme });
let withTheme = (Component) => ({ theme, ...props }) => /* @__PURE__ */ React.createElement(Component, { theme: { ...useTheme(), ...theme }, ...props });
export {
  ThemeConsumer,
  ThemeProvider,
  defaultTheme,
  useTheme,
  withTheme
};
